/*
 *	EXAM4.C
 *
 *	Simple network reporting example as described in the "EXAMPLES" section
 *	of the Logical Systems "TRANSPUTER 'C' LIBRARY DESCRIPTION"
 *	documentation.
 */

#include	<stdio.h>
#include	<conc.h>

main()
	{
	Channel			*chan;
	int			id = 0;

	if(_node_number == 1)
		{
/*
 *	We are the root Transputer, inform the user as the
 *	various node addresses arrive.  Note that we listen for
 *	input from the bootstrap link also but this doesn't
 *	matter since it shouldn't generate any output!
 */
		printf("Root node ID # was %d\n",_node_number);
		printf("Booted from input channel: %p\n",_boot_chan_in);
		while(1)
			{
			chan = LINK0IN +
				ProcAlt(LINK0IN,LINK1IN,LINK2IN,LINK3IN,0);
			printf("\nMessage on input channel: %p\n",chan);
			ChanIn(chan,&id,2);
			printf("Message was node ID # %d\n",id);
			}
		}
	else
		{
/*
 *	We are not the root, look at all input links and send
 *	any node addresses we get out the link we were
 *	bootstrapped on.
 */
		ChanOut(_boot_chan_out,&_node_number,2);
		while(1)
			{
			chan = LINK0IN +
				ProcAlt(LINK0IN,LINK1IN,LINK2IN,LINK3IN,0);
			ChanIn(chan,&id,2);
			ChanOut(_boot_chan_out,&id,2);
			}
		}
	}
