/* mdemo.c: graphics demo showing initialization of screen */

#include "graph.h"
#include "mouse.h"
#include "text.h"

int MaxX, MaxY;
int GraphDriver, GraphMode, ErrorCode;

void Initialize(void)
{
	char error[80];

	GraphDriver = DETECT; 		                     /* Request auto-detection */
	initgraph( &GraphDriver, &GraphMode, "" );      /* Use current directory */
	ErrorCode = graphresult();		          /* Read result of initialization */
	if( ErrorCode != grOk ) { 		              /* Error occured during init */
		grapherrormsg(ErrorCode,error);
		printf(" Graphics System Error: %s\n", error );
		exit(1);
	}

	MaxX = getmaxx();
	MaxY = getmaxy();															    /* Read size of screen */
}

void main(void)
{
	int mresult;
	int button,x,y;

	Initialize();
	mresult = MouseReset();
	if (!mresult) {
		printf(" Mouse driver not loaded.\n");
		exit(2);
	}
	setcolor(WHITE);
	rectangle(0,0,MaxX,MaxY);
	outtextxy(232,470,"Press any key to exit.");

	ShowMouseCursor();
	do {
		GetMousePosButton(&button,&x,&y);
		switch (button) {
			case LB: sound(500);
							 while (button) GetMousePosButton(&button,&x,&y);
							 nosound();
							 break;
			case MB: sound(1000);
							 while (button) GetMousePosButton(&button,&x,&y);
							 nosound();
							 break;
			case RB: sound(1500);
							 while (button) GetMousePosButton(&button,&x,&y);
							 nosound();
							 break;
		default: break;
		}
	} while (!kbhit());
	HideMouseCursor();
	closegraph();
}