/*
 *	fcntl.h
 *
 *	Copyright 1991 by Logical Systems.
 */

#ifndef	_FCNTL				/* Avoid duplication */
#define	_FCNTL	1

#define	O_APPEND	0x0001		/* All write append */
#define	O_BINARY	0x0002		/* No text translation (binary file) */
#define	O_CREAT 	0x0004		/* If file doesn't exist create it */
#define	O_EXCL		0x0008		/* Error if O_CREAT and file exists */
#define	O_NONBLOCK	0x0010		/* Return if would block */
#define	O_RDONLY	0x0020		/* Open file for reading */
#define	O_RDWR		0x0040		/* Open file for reading & writing */
#define	O_TEXT		0x0080		/* Perform translation (text file) */
#define	O_TRUNC 	0x0100		/* Open file and nuke contents */
#define	O_WRONLY	0x0200		/* Open file for writing */

/*
 *	The following definitions really belong in "/sys/stat.h", but since
 *	we don't support "stat" or "fstat", and they are also used with the
 *	above macros in "open" and "creat" calls, we include them here.
 */

#define	S_IREAD		0x0001		/* Allow reading */
#define	S_IWRITE	0x0002		/* Allow writing */

#endif	/* _FCNTL */
