/*
 *	File:	acos64.c
 *
 *	Implements T800/T414 64 bit floating point "acos(x)".
 *
 *	Based on INMOS supplied code.  Modified by Logical Systems for correct
 *	ANSI "C" setting of "errno" in ERANGE/EDOM situations.
 */

#include	<inline.h>
#include	<math.h>
#include	<stddef.h>
#undef		sqrt			/* To avoid conflicts */

#pragma	asm_expand			/* Recognize EDOM/ERANGE in "asm" */

double
acos(double x)
	{
	#pragma	asm
#ifdef	T800
;
;	T800 64 bit version
;
	.ext	errno
	_asm_ajw(-14)
	.ldc	0
	stl	13
	fpldzerodb
	ldlp	[x]
	fpldnldb
	fpgt
	stl	13
	.ldc	0
	stl	8
	ldlp	[x]
	fpldnldb
	fpnan
	stl	8
	ldlp	[x]
	fpldnldb
	fpuabs
	ldlp	11
	fpstnldb
	ldl	8
	cj	@L1
	ldlp	[x]
	ldlp	9
	.ldc	8
	move
L0:	.ldc	EDOM			;Domain error (input is NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	j	@L14
	.align
data:	.dw	0x00000000
	.dw	0x3ff00000
	.dw	0x00000010
	.dw	0x7ff00000
	.dw	0x54442d18
	.dw	0x400921fb
	.dw	0x00000000
	.dw	0x3fe00000
	.dw	0x00000000
	.dw	0x3e500000
	.dw	0xb5e61e65
	.dw	0xbfe64bbd
	.dw	0x64ec3928
	.dw	0x40244e17
	.dw	0xa9a6daa0
	.dw	0xc043d82c
	.dw	0x360ad48b
	.dw	0x404c9aa7
	.dw	0xa83a0a63
	.dw	0xc03b5e55
	.dw	0x6ef98620
	.dw	0xc037d2e8
	.dw	0x96591c70
	.dw	0x4062de7c
	.dw	0xfc56a848
	.dw	0xc077ddce
	.dw	0x101eb843
	.dw	0x407a124f
	.dw	0x3e2b87cd
	.dw	0xc06486c0
	.dw	0x54442d18
	.dw	0x3ff921fb
L1:	.ldc	data
	stl	[x]			;Re-use
	ldlp	11
	fpldnldb
	ldl	[x]
	fpldnldb
	fpgt
	cj	@L2
	ldl	[x]
	ldnlp	2
	ldlp	9
	.ldc	8
	move
	j	@L0			;Domain error (input > |1.0|)
L2:	ldlp	11
	fpldnldb
	ldl	[x]
	fpldnldb
	fpeq
	cj	@L5
	ldl	13
	cj	@L3
	ldl	[x]
	ldnlp	4
	ldlp	9
	.ldc	8
	move
	j	@L14
L3:	fpldzerodb
	ldlp	9
	fpstnldb
	j	@L14
L5:	ldlp	11
	fpldnldb
	ldl	[x]
	ldnlp	6
	fpldnldb
	fpgt
	cj	@L10
	ldlp	11
	ldl	[x]
	fpldnldb
	fpldnldb
	fpsub
	ldlp	0
	fpstnldb
	ldlp	0
	fpldnldb
	fpudivby2
	ldlp	4
	fpstnldb
	ldlp	4
	fpldnldb
	fpusqrtfirst
	fpusqrtstep
	fpusqrtstep
	fpusqrtstep
	fpusqrtstep
	fpusqrtstep
	fpusqrtlast
	ldlp	6
	fpstnldb
	ldlp	6
	fpldnldb
	fpumulby2
	ldlp	6
	fpstnldb
	ldl	[x]
	ldnlp	8
	fpldnldb
	ldlp	6
	fpldnldb
	fpgt
	cj	@L6
	ldl	6
	stl	2
	ldl	7
	stl	3
	j	@L7
L6:	ldl	[x]
	ldnlp	10
	ldlp	4
	fpldnldb
	fpldnlmuldb
	ldl	[x]
	ldnlp	12
	fpldnladddb
	ldlp	4
	fpldnlmuldb
	ldl	[x]
	ldnlp	14
	fpldnladddb
	ldlp	4
	fpldnlmuldb
	ldl	[x]
	ldnlp	16
	fpldnladddb
	ldlp	4
	fpldnlmuldb
	ldl	[x]
	ldnlp	18
	fpldnladddb
	ldlp	4
	fpldnlmuldb
	ldlp	4
	ldl	[x]
	ldnlp	20
	fpldnldb
	fpldnladddb
	ldlp	4
	fpldnlmuldb
	ldl	[x]
	ldnlp	22
	fpldnladddb
	ldlp	4
	fpldnlmuldb
	ldl	[x]
	ldnlp	24
	fpldnladddb
	ldlp	4
	fpldnlmuldb
	ldl	[x]
	ldnlp	26
	fpldnladddb
	ldlp	4
	fpldnlmuldb
	ldl	[x]
	ldnlp	28
	fpldnladddb
	fpdiv
	ldlp	6
	fpldnlmuldb
	ldlp	6
	fpldnladddb
	ldlp	2
	fpstnldb
L7:	ldl	13
	cj	@L8
	ldlp	2
	ldl	[x]
	ldnlp	4
	fpldnldb
	fpldnldb
	fpsub
	ldlp	9
	fpstnldb
	j	@L9
L8:	ldl	2
	stl	9
	ldl	3
	stl	10
L9:	j	@L14
L10:	ldl	[x]
	ldnlp	8
	fpldnldb
	ldlp	11
	fpldnldb
	fpgt
	cj	@L11
	ldl	11
	stl	6
	ldl	12
	stl	7
	j	@L12
L11:	ldl	11
	stl	4
	ldl	12
	stl	5
	ldlp	4
	ldlp	4
	fpldnldb
	fpldnlmuldb
	ldlp	2
	fpstnldb
	ldl	[x]
	ldnlp	10
	ldlp	2
	fpldnldb
	fpldnlmuldb
	ldl	[x]
	ldnlp	12
	fpldnladddb
	ldlp	2
	fpldnlmuldb
	ldl	[x]
	ldnlp	14
	fpldnladddb
	ldlp	2
	fpldnlmuldb
	ldl	[x]
	ldnlp	16
	fpldnladddb
	ldlp	2
	fpldnlmuldb
	ldl	[x]
	ldnlp	18
	fpldnladddb
	ldlp	2
	fpldnlmuldb
	ldlp	2
	ldl	[x]
	ldnlp	20
	fpldnldb
	fpldnladddb
	ldlp	2
	fpldnlmuldb
	ldl	[x]
	ldnlp	22
	fpldnladddb
	ldlp	2
	fpldnlmuldb
	ldl	[x]
	ldnlp	24
	fpldnladddb
	ldlp	2
	fpldnlmuldb
	ldl	[x]
	ldnlp	26
	fpldnladddb
	ldlp	2
	fpldnlmuldb
	ldl	[x]
	ldnlp	28
	fpldnladddb
	fpdiv
	ldlp	4
	fpldnlmuldb
	ldlp	4
	fpldnladddb
	ldlp	6
	fpstnldb
L12:	ldl	13
	cj	@L13
	ldl	[x]
	ldnlp	30
	ldlp	6
	fpldnldb
	fpldnladddb
	ldlp	9
	fpstnldb
	j	@L14
L13:	ldlp	6
	ldl	[x]
	ldnlp	30
	fpldnldb
	fpldnldb
	fpsub
	ldlp	9
	fpstnldb
L14:	ldlp	9
	fpldnldb
	_asm_ajw(14)
	ret
#else	/* T800 */
;
;	T414 64 bit version (from D700D).  NO attempt is made here to optimize
;	the OCCAM generated code (hope to get to this someday...)
;
	.ext	errno
	.ext	_FPstate
	.ext	_iexp64
	.ext	_ras64
	.ext	_r64op
	.ext	sqrt
	_asm_ajw(-19)
	.ldc	data
	stl	18
	ldlp	[x]
	ldlp	14
	.ldc	8
	move
	.ldc	0
	stl	13
	.ldc	0
	ldl	15
	gt
	stl	13
	ldl	14
	stl	11
	ldl	15
	.ldc	2147483647		;~MOSTNEG
	and
	stl	12
	ldl	12
	.ldc	2146435072		;MSW DRealInf
	gt
	eqc	0
	cj	@L2
	ldl	12
	.ldc	2146435072		;MSW DRealInf
	diff
	eqc	0
	cj	@L1
	ldl	11
	mint
	xor
	mint
	gt
L1:	eqc	0
L2:	eqc	0
	cj	@L3
	ldlp	[x]
	ldlp	16
	.ldc	8
	move
	.ldc	EDOM			;Domain error (input is Inf/NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	j	@L28
	.align
data:	.dw	0x00000000		;"undefined" NaN
	.dw	0x7ff00002
	.dw	0x54442d18
	.dw	0x400921fb
	.dw	0x00000000
	.dw	0x3ff00000
	.dw	0x00000000
	.dw	0x40000000
	.dw	0x00000000
	.dw	0x00000000
	.dw	0x54442d18
	.dw	0x3ff921fb
L3:	ldl	12
	.ldc	1072693248
	gt
	eqc	0
	cj	@L5
	ldl	12
	.ldc	1072693248
	diff
	eqc	0
	cj	@L4
	ldl	11
	mint
	xor
	mint
	gt
L4:	eqc	0
L5:	eqc	0
	cj	@L6
	ldl	18
	ldlp	16
	.ldc	8
	move
	.ldc	EDOM			;Domain error (input > |1.0|)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	j	@L28
L6:	ldl	11
	ldl	12
	.ldc	1072693248
	diff
	or
	eqc	0
	cj	@L9
	ldl	13
	cj	@L7
	ldl	18
	ldnlp	2
	ldlp	16
	.ldc	8
	move
	j	@L8
L7:	.ldc	0
	stl	16
	.ldc	0
	stl	17
L8:	j	@L28
L9:	ldl	12
	.ldc	1071644672
	gt
	eqc	0
	cj	@L11
	ldl	12
	.ldc	1071644672
	diff
	eqc	0
	cj	@L10
	ldl	11
	mint
	xor
	mint
	gt
L10:	eqc	0
L11:	eqc	0
	cj	@L22
	ldl	11
	stl	9
	ldl	12
	stl	10
	ldlp	9
	stl	0
	.ldc	1
	ldl	18
	ldnlp	4
	ldlp	7
	call	@_r64op
	ldlp	7
	stl	2
	.ldc	131072
	ldl	2
	ldnl	1
	gt
	eqc	0
	cj	@L13
	.ldc	131072
	ldl	2
	ldnl	1
	diff
	eqc	0
	cj	@L12
	mint
	ldl	2
	ldnl	0
	mint
	xor
	gt
L12:	eqc	0
L13:	eqc	0
	cj	@L14
	ldl	2
	stl	1
	ldl	18
	ldnlp	6
	stl	0
	.ldc	3
	ldl	1
	ldlp	5
	call	@_r64op
	j	@L15
L14:	.ldc	-1
	ldlp	7
	ldlp	5
	call	@_iexp64
L15:	ldl	6			;MSW of double
	ldl	5			;LSW of double
#ifdef	STATIC_LINK
	ldl	[?slb]
#endif	/* STATIC_LINK */
	call	@sqrt
	.ldc	_FPstate		;Store FAreg result in 1,2
	stl	1
	ldl	1
	ldnl	1
	stl	2
	ldl	1
	ldnl	0
	stl	1
	.ldc	1
	ldlp	1
	ldlp	7
	call	@_iexp64
	ldlp	7
	stl	2
	.ldc	1045430272
	ldl	2
	ldnl	1
	gt
	eqc	0
	cj	@L17
	.ldc	1045430272
	ldl	2
	ldnl	1
	diff
	eqc	0
	cj	@L16
	mint
	ldl	2
	ldnl	0
	mint
	xor
	gt
L16:	eqc	0
L17:	eqc	0
	cj	@L18
	ldl	2
	stl	1
	ldl	1
	ldlp	3
	.ldc	8
	move
	j	@L19
L18:	ldlp	5
	ldlp	7
	ldlp	3
	call	@_ras64
L19:	ldl	13
	cj	@L20
	ldlp	3
	stl	0
	.ldc	1
	ldl	18
	ldnlp	2
	ldlp	16
	call	@_r64op
	j	@L21
L20:	ldl	3
	stl	16
	ldl	4
	stl	17
L21:	j	@L28
L22:	.ldc	1045430272
	ldl	12
	gt
	eqc	0
	cj	@L24
	.ldc	1045430272
	ldl	12
	diff
	eqc	0
	cj	@L23
	mint
	ldl	11
	mint
	xor
	gt
L23:	eqc	0
L24:	eqc	0
	cj	@L25
	ldl	11
	stl	7
	ldl	12
	stl	8
	ldl	7
	stl	9
	ldl	8
	stl	10
	j	@L26
L25:	ldl	11
	stl	7
	ldl	12
	stl	8
	ldl	18
	ldnlp	8
	ldlp	7
	ldlp	9
	call	@_ras64
L26:	ldl	13
	cj	@L27
	ldlp	9
	stl	0
	.ldc	0
	ldl	18
	ldnlp	10
	ldlp	16
	call	@_r64op
	j	@L28
L27:	ldlp	9
	stl	0
	.ldc	1
	ldl	18
	ldnlp	10
	ldlp	16
	call	@_r64op
L28:	ldlp	16
	.ldc	_FPstate		;Addr of "soft" FAreg
	.ldc	8
	move
	_asm_ajw(19)
	ret
#endif	/* T800 */
	#pragma	endasm
	}
