/*
 *	File:	asin32.c
 *
 *	Implements T800/T414 32 bit floating point "asinf(x)/asin(x)".
 *
 *	Based on INMOS supplied code.  Modified by Logical Systems for correct
 *	ANSI "C" setting of "errno" in ERANGE/EDOM situations.
 */

#include	<inline.h>
#include	<math.h>
#include	<stddef.h>

#pragma	asm_expand			/* Recognize EDOM/ERANGE in "asm" */

float
asinf(float x)
	{
	#pragma	asm
#ifdef	DOUBLE32
	.pub	asin
asin:
#endif	DOUBLE32

#ifdef	T800
;
;	T800 32 bit version
;
	.ext	errno
	_asm_ajw(-9);
	.ldc	data
	stl	8
	.ldc	0
	stl	7
	fpldzerosn
	ldlp	[x]
	fpldnlsn
	fpgt
	stl	7
	.ldc	0
	stl	4
	ldlp	[x]
	fpldnlsn
	fpnan
	stl	4
	ldlp	[x]
	fpldnlsn
	fpuabs
	ldlp	5
	fpstnlsn
	ldl	4
	cj	@L1
	ldl	[x]
	stl	6
L0:	.ldc	EDOM			;Domain error (input is NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	j	@L13
	.align
data:	.dw	0x3f800000
	.dw	0x7f800010
	.dw	0xbfc90fdb
	.dw	0x3fc90fdb
	.dw	0x3f000000
	.dw	0x39800000
	.dw	0xbf012066
	.dw	0x3f6f166c
	.dw	0xc0b18d0c
	.dw	0x40b350f0
L1:	ldlp	5
	fpldnlsn
	ldl	8
	fpldnlsn
	fpgt
	cj	@L2
	ldl	8
	ldnl	1
	stl	6
	j	@L0			;Domain error (input > |1.0|)
L2:	ldlp	5
	fpldnlsn
	ldl	8
	fpldnlsn
	fpeq
	cj	@L5
	ldl	7
	cj	@L3
	ldl	8
	ldnl	2
	stl	6
	j	@L4
L3:	ldl	8
	ldnl	3
	stl	6
L4:	j	@L13
L5:	ldlp	5
	fpldnlsn
	ldl	8
	ldnlp	4
	fpldnlsn
	fpgt
	cj	@L10
	ldlp	5
	ldl	8
	fpldnlsn
	fpldnlsn
	fpsub
	fpudivby2
	ldlp	2
	fpstnlsn
	ldlp	2
	fpldnlsn
	fpusqrtfirst
	fpusqrtstep
	fpusqrtstep
	fpusqrtlast
	ldlp	3
	fpstnlsn
	ldlp	3
	fpldnlsn
	fpumulby2
	ldlp	3
	fpstnlsn
	ldl	8
	ldnlp	5
	fpldnlsn
	ldlp	3
	fpldnlsn
	fpgt
	cj	@L6
	fpldzerosn
	ldlp	3
	fpldnlsn
	fpsub
	ldlp	1
	fpstnlsn
	j	@L7
L6:	fpldzerosn
	ldlp	3
	fpldnlsn
	fpsub
	ldlp	0
	fpstnlsn
	ldl	8
	ldnlp	6
	ldlp	2
	fpldnlsn
	fpldnlmulsn
	ldl	8
	ldnlp	7
	fpldnladdsn
	ldlp	2
	fpldnlmulsn
	ldlp	2
	ldl	8
	ldnlp	8
	fpldnlsn
	fpldnladdsn
	ldlp	2
	fpldnlmulsn
	ldl	8
	ldnlp	9
	fpldnladdsn
	fpdiv
	ldlp	0
	fpldnlmulsn
	ldlp	0
	fpldnladdsn
	ldlp	1
	fpstnlsn
L7:	ldl	7
	cj	@L8
	fpldzerosn
	ldlp	1
	ldl	8
	ldnlp	3
	fpldnlsn
	fpldnladdsn
	fpsub
	ldlp	6
	fpstnlsn
	j	@L9
L8:	ldlp	1
	ldl	8
	ldnlp	3
	fpldnlsn
	fpldnladdsn
	ldlp	6
	fpstnlsn
L9:	j	@L13
L10:	ldl	8
	ldnlp	5
	fpldnlsn
	ldlp	5
	fpldnlsn
	fpgt
	cj	@L11
	ldl	[x]
	stl	6
	j	@L13
L11:	ldl	5
	stl	2
	ldlp	5
	ldlp	5
	fpldnlsn
	fpldnlmulsn
	ldlp	1
	fpstnlsn
	ldl	8
	ldnlp	6
	ldlp	1
	fpldnlsn
	fpldnlmulsn
	ldl	8
	ldnlp	7
	fpldnladdsn
	ldlp	1
	fpldnlmulsn
	ldlp	1
	ldl	8
	ldnlp	8
	fpldnlsn
	fpldnladdsn
	ldlp	1
	fpldnlmulsn
	ldl	8
	ldnlp	9
	fpldnladdsn
	fpdiv
	ldlp	2
	fpldnlmulsn
	ldlp	2
	fpldnladdsn
	ldlp	3
	fpstnlsn
	ldl	7
	cj	@L12
	fpldzerosn
	ldlp	3
	fpldnlsn
	fpsub
	ldlp	6
	fpstnlsn
	j	@L13
L12:	ldl	3
	stl	6
L13:	ldlp	6
	fpldnlsn
	_asm_ajw(9);
#else	/* T800 */
;
;	T414 32 bit version
;
#endif	/* T800 */
	#pragma	endasm
	}
