/*
 *	comm.c
 *
 *	Communication primitives for the Transputer.
 *
 *	Based on the Transputer concurrency function library designed by
 *	Jeffrey Mock of PIXAR (Version 2).  This implementation by Scott Lloyd
 *	of CSA.  Modifications by Kirk Bailey of Logical Systems.
 *
 *	Copyright 1987-1991 Computer System Architects and Logical Systems.
 */

#include	<inline.h>
#include	<conc.h>

#undef	ChanIn

void
ChanIn(Channel *c,void *p,int cnt)
	{
	#pragma asm
	LDL	[p]
	LDL	[c]
	LDL	[cnt]
	IN
	#pragma endasm
	}

#undef	ChanInChar

char
ChanInChar(Channel *c)
	{
	char	tmp;
	;
	#pragma asm
	LDLP	[tmp]
	LDL	[c]
	LDC	1
	IN
	#pragma endasm
	return(tmp);
	}

#undef	ChanInInt

int
ChanInInt(Channel *c)
	{
	int	tmp;
	;
	#pragma asm
	LDLP	[tmp]
	LDL	[c]
#ifdef	T212
	LDC	2
#else	/* !T212 */
	LDC	4
#endif	/* T212 */
	IN
	#pragma endasm
	return(tmp);
	}

#undef	ChanOut

void
ChanOut(Channel *c,void *p,int cnt)
	{
	#pragma asm
	LDL	[p]
	LDL	[c]
	LDL	[cnt]
	OUT
	#pragma endasm
	}

#undef	ChanOutChar

void
ChanOutChar(Channel *c,int ch)
	{
	#pragma asm
	LDLP	[ch]
	LDL	[c]
	LDC	1
	OUT
	#pragma endasm
	}

#undef	ChanOutInt

void
ChanOutInt(Channel *c,int n)
	{
	#pragma asm
	LDLP	[n]
	LDL	[c]
#ifdef	T212
	LDC	2
#else	/* !T212 */
	LDC	4
#endif	/* T212 */
	OUT
	#pragma endasm
	}

#undef	ChanReset

int
ChanReset(Channel *c)
	{
	#pragma asm
	LDL	[c]
	RESETCH
	#pragma endasm
	}
