/*
 *	File:	cos64.c
 *
 *	Implements T800/T414 64 bit floating point "cos(x)".
 *
 *	Based on INMOS supplied code.  Modified by Logical Systems for correct
 *	ANSI "C" setting of "errno" in ERANGE/EDOM situations.
 */

#include	<inline.h>
#include	<math.h>
#include	<stddef.h>

#pragma	asm_expand			/* Recognize EDOM/ERANGE in "asm" */

double
cos(double x)
	{
	#pragma	asm
#ifdef	T800
;
;	T800 64 bit version.  A small amount of effort has been put into
;	optimizing the OCCAM compiler generated code (D700B?), more should be
;	spent someday!
;
	.ext	errno
	_asm_ajw(-8)
	ldlp	[x]
	fpldnldb
	fpuabs
	ldlp	6
	fpstnldb
	ldlp	[x]			;Parameter offset
	fpldnldb
	fpnan
	cj	@L1
	ldlp	[x]
	ldlp	4
	.ldc	8
	move
	.ldc	EDOM			;Domain error (input is NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	j	@L10
	.align
data:	.dw	0x54442d18
	.dw	0x41a921fb
;
;	The following floating point constant represents the value of the
;	"inaccurate" NaN.  The original INMOS code used a value for this which
;	is inconsistent with the latest INMOS Compiler Writers' Guide.  The
;	value has been changed to reflect the one used in the "Guide".
;
	.dw	0x80000000		;Was 0x00000004
	.dw	0x7ff00000		;Was 0x7FF00000
	.dw	0x00000000
	.dw	0x3e500000
	.dw	0x00000000
	.dw	0x3ff00000
	.dw	0x54442d18
	.dw	0x3ff921fb
	.dw	0x6dc9c883
	.dw	0x3fd45f30
	.dw	0x00000000
	.dw	0x3fe00000
	.dw	0x00000000
	.dw	0x40092200
	.dw	0x4b9ee59e
	.dw	0xbee2aeef
	.dw	0x50442d18
	.dw	0x3ff921fb
	.dw	0x6993df95
	.dw	0x3ce880ff
	.dw	0xdc08499c
	.dw	0xbd6ae420
	.dw	0x686ad430
	.dw	0x3de6123c
	.dw	0x4b5dc0ac
	.dw	0xbe5ae645
	.dw	0xa524f064
	.dw	0x3ec71de3
	.dw	0x1a013e1b
	.dw	0xbf2a01a0
	.dw	0x111110b1
	.dw	0x3f811111
	.dw	0x55555555
	.dw	0xbfc55555
L1:
	.ldc	data
	stl	[x]			;Reuse
	ldlp	6
	fpldnldb
	ldl	[x]
	fpldnldb
	fpgt
	cj	@L2
	ldl	[x]
	ldnlp	2
	ldlp	4
	.ldc	8
	move
	j	@L10
L2:	ldl	[x]
	ldnlp	4
	fpldnldb
	ldlp	6
	fpldnldb
	fpgt
	cj	@L3
	ldl	[x]
	ldnlp	6
	ldlp	4
	.ldc	8
	move
	j	@L10
L3:	.ldc	0
	stl	[x]+1
	ldlp	6
	ldl	[x]
	ldnlp	8
	fpldnldb
	fpldnladddb
	ldl	[x]
	ldnlp	10
	fpldnlmuldb
	fprtoi32
	ldlp	3
	fpstnli32
	ldlp	3
	fpi32tor64
	ldl	[x]
	ldnlp	12
	fpldnldb
	fpsub
	ldlp	1
	fpstnldb
	ldl	3
	.ldc	1
	and
	eqc	1
	stl	[x]+1
	ldlp	6
	fpldnldb
	ldlp	1
	ldl	[x]
	ldnlp	14
	fpldnldb
	fpldnlmuldb
	fpsub
	ldlp	1
	ldl	[x]
	ldnlp	16
	fpldnldb
	fpldnlmuldb
	fpsub
	ldlp	6
	fpstnldb
	fpldzerodb
	ldlp	6
	fpldnldb
	fpgt
	cj	@L4
	fpldzerodb
	ldlp	6
	fpldnldb
	fpsub
	ldlp	6
	fpstnldb
	ldl	[x]+1
	eqc	0
	stl	[x]+1
L4:	ldl	[x]
	ldnlp	4
	fpldnldb
	ldlp	6
	fpldnldb
	fpgt
	cj	@L5
	ldl	6
	stl	2
	ldl	7
	stl	3
	j	@L7
L5:	ldlp	6
	fpldnldb
	ldl	[x]
	ldnlp	18
	fpldnldb
	fpgt
	cj	@L6
	ldl	[x]
	ldnlp	6
	ldlp	2
	.ldc	8
	move
	j	@L7
L6:	ldlp	6
	ldlp	6
	fpldnldb
	fpldnlmuldb
	ldlp	0
	fpstnldb
	ldlp	0
	ldl	[x]
	ldnlp	20
	fpldnldb
	fpldnlmuldb
	ldl	[x]
	ldnlp	22
	fpldnladddb
	ldlp	0
	fpldnlmuldb
	ldl	[x]
	ldnlp	24
	fpldnladddb
	ldlp	0
	fpldnlmuldb
	ldl	[x]
	ldnlp	26
	fpldnladddb
	ldlp	0
	fpldnlmuldb
	ldl	[x]
	ldnlp	28
	fpldnladddb
	ldlp	0
	fpldnlmuldb
	ldl	[x]
	ldnlp	30
	fpldnladddb
	ldlp	0
	fpldnlmuldb
	ldl	[x]
	ldnlp	32
	fpldnladddb
	ldlp	0
	fpldnlmuldb
	ldl	[x]
	ldnlp	34
	fpldnladddb
	ldlp	0
	fpldnlmuldb
	ldlp	6
	fpldnlmuldb
	ldlp	6
	fpldnladddb
	ldlp	2
	fpstnldb
L7:	ldl	[x]+1
	cj	@L9
	fpldzerodb
	ldlp	2
	fpldnldb
	fpsub
	ldlp	4
	fpstnldb
	j	@L10
L9:	ldl	2
	stl	4
	ldl	3
	stl	5
L10:	ldlp	4
	fpldnldb
	_asm_ajw(8)
	ret
#else	/* T800 */
;
;	T414 64 bit version (from D700D).  NO attempt is made here to optimize
;	the OCCAM generated code (for example see lines after label "L3", hope
;	to get to this someday...)
;
	.ext	errno
	.ext	_fix64
	.ext	_fmul64
	.ext	_FPstate
	.ext	_iexp64
	.ext	_refl64
	.ext	_r64fmi
	.ext	_r64op
	.ext	_r64toi
	_asm_ajw(-20)
	.ldc	data
	stl	19
	ldlp	[x]			;Parameter
	ldlp	15
	.ldc	8
	move
	.ldc	_FPstate		;Addr of "soft" FAreg
	stl	[x]			;Re-use
	ldlp	13
	stl	12
	ldl	15
	ldl	12
	stnl	0
	ldl	16
	.ldc	2147483647		;~MOSTNEG
	and				;|x|
	ldl	12
	stnl	1
	.ldc	2146435072		;MSW DRealInf
	ldl	12
	ldnl	1
	gt
	eqc	0
	cj	@L2
	.ldc	2146435072		;MSW DRealInf
	ldl	12
	ldnl	1
	diff
	eqc	0
	cj	@L1
	mint
	ldl	12
	ldnl	0
	mint
	xor
	gt
L1:	eqc	0
L2:	cj	@L5
	ldl	12
	ldnl	0
	ldl	12
	ldnl	1
	.ldc	2146435072		;MSW DRealInf
	diff
	or
	eqc	0
	cj	@L3
	ldl	19
	ldlp	17
	.ldc	8
	move				;"undefined" NaN
	.ldc	EDOM			;Domain error (input is Inf)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	j	@L4
	.align
data:	.dw	0x00000000		;"undefined" NaN
	.dw	0x7ff00002
	.dw	0x80000000		;"inexact" NaN
	.dw	0x7ff00000
	.dw	0x00000000		;"1.0"
	.dw	0x3ff00000
	.dw	0x54442d18
	.dw	0x3ff921fb
	.dw	0x6dc9c883
	.dw	0x3fd45f30
	.dw	0x00000000
	.dw	0x40092200
	.dw	0x4b9ee59e
	.dw	0xbee2aeef
	.dw	0x6203fda6
	.dw	0x00000000
	.dw	0x00000000
	.dw	0x00000000
L3:	ldl	15
	stl	10
	ldl	16
	stl	11
	ldl	10
	stl	17
	ldl	11
	stl	18
	.ldc	EDOM			;Domain error (input is NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
L4:	j	@L21
L5:	ldl	12
	ldnl	1
	.ldc	1101603323
	gt
	eqc	0
	cj	@L7
	ldl	12
	ldnl	1
	.ldc	1101603323
	diff
	eqc	0
	cj	@L6
	ldl	12
	ldnl	0
	mint
	xor
	.ldc	-733729512
	gt
L6:	eqc	0
L7:	eqc	0
	cj	@L8
	ldl	19
	ldnlp	2
	ldlp	17
	.ldc	8
	move				;"inexact" NaN
	j	@L21
L8:	.ldc	1045430272
	ldl	12
	ldnl	1
	gt
	eqc	0
	cj	@L10
	.ldc	1045430272
	ldl	12
	ldnl	1
	diff
	eqc	0
	cj	@L9
	mint
	ldl	12
	ldnl	0
	mint
	xor
	gt
L9:	eqc	0
L10:	eqc	0
	cj	@L11
	ldl	19
	ldnlp	4
	ldlp	17
	.ldc	8
	move				;Return 1.0 if arg small enough
	j	@L21
L11:	.ldc	0
	stl	11
	ldl	12
	stl	10
	ldl	19
	ldnlp	6
	stl	0
	.ldc	0
	ldl	10
	ldlp	5
	call	@_r64op
	ldl	19
	ldnlp	8
	stl	0
	.ldc	2
	ldlp	5
	ldlp	3
	call	@_r64op
	ldlp	3
	.ldc	1
	call	@_r64toi
	stl	7
	ldl	7
	.ldc	1
	and
	eqc	1
	stl	11
	ldl	7
	.ldc	1
	shl
	adc	-1
	ldlp	5
	call	@_r64fmi
	.ldc	-1
	ldlp	5
	ldlp	8
	call	@_iexp64
	ldl	19
	ldnlp	10
	stl	0
	.ldc	2
	ldlp	8
	ldlp	3
	call	@_r64op
	ldlp	3
	stl	0
	.ldc	1
	ldl	10
	ldlp	1
	call	@_r64op
	ldl	19
	ldnlp	12
	stl	0
	.ldc	2
	ldlp	8
	ldlp	3
	call	@_r64op
	ldlp	3
	stl	0
	.ldc	1
	ldlp	1
	ldlp	5
	call	@_r64op
	ldlp	5
	ldl	10
	.ldc	8
	move
	.ldc	0
	ldl	12
	ldnl	1
	gt
	cj	@L12
	ldl	12
	ldnl	0
	stl	9
	ldl	12
	ldnl	1
	.ldc	2147483647
	and
	stl	10
	ldlp	9
	ldl	12
	.ldc	8
	move
	ldl	11
	eqc	0
	stl	11
L12:	.ldc	1045430272
	ldl	12
	ldnl	1
	gt
	eqc	0
	cj	@L14
	.ldc	1045430272
	ldl	12
	ldnl	1
	diff
	eqc	0
	cj	@L13
	mint
	ldl	12
	ldnl	0
	mint
	xor
	gt
L13:	eqc	0
L14:	eqc	0
	cj	@L15
	ldl	12
	stl	10
	ldl	10
	ldlp	17
	.ldc	8
	move
	j	@L19
L15:	ldl	12
	ldnl	1
	.ldc	1073291771
	gt
	eqc	0
	cj	@L17
	ldl	12
	ldnl	1
	.ldc	1073291771
	diff
	eqc	0
	cj	@L16
	ldl	12
	ldnl	0
	mint
	xor
	.ldc	-800838376
	gt
L16:	eqc	0
L17:	eqc	0
	cj	@L18
	ldl	19
	ldnlp	4
	ldlp	17
	.ldc	8
	move
	j	@L19
L18:	ldl	12
	stl	8
	.ldc	-1
	ldl	8
	ldlp	6
	call	@_iexp64
	ldlp	6
	ldlp	9
	call	@_fix64
	ldlp	9
	ldlp	9
	ldlp	6
	call	@_fmul64
	ldl	6
	stl	9
	ldl	7
	stl	10
	ldl	19
	ldnlp	14
	ldlp	9
	ldlp	6
	call	@_fmul64
	.ldc	0
	ldl	6
	.ldc	467608568
	lsum
	stl	2
	ldl	7
	.ldc	-27
	ladd
	stl	3
	ldlp	2
	ldlp	9
	ldlp	4
	call	@_fmul64
	.ldc	0
	ldl	4
	.ldc	-1894114635
	lsum
	stl	2
	ldl	5
	.ldc	1412
	ladd
	stl	3
	ldlp	2
	ldlp	9
	ldlp	6
	call	@_fmul64
	.ldc	0
	ldl	6
	.ldc	-710602245
	lsum
	stl	2
	ldl	7
	.ldc	-55091
	ladd
	stl	3
	ldlp	2
	ldlp	9
	ldlp	4
	call	@_fmul64
	.ldc	0
	ldl	4
	.ldc	-1524305821
	lsum
	stl	2
	ldl	5
	.ldc	1514979
	ladd
	stl	3
	ldlp	2
	ldlp	9
	ldlp	6
	call	@_fmul64
	.ldc	0
	ldl	6
	.ldc	1609309790
	lsum
	stl	2
	ldl	7
	.ldc	-27269634
	ladd
	stl	3
	ldlp	2
	ldlp	9
	ldlp	4
	call	@_fmul64
	.ldc	0
	ldl	4
	.ldc	286306316
	lsum
	stl	2
	ldl	5
	.ldc	286331153
	ladd
	stl	3
	ldlp	2
	ldlp	9
	ldlp	6
	call	@_fmul64
	.ldc	0
	ldl	6
	.ldc	-1431655170
	lsum
	stl	2
	ldl	7
	.ldc	-1431655766
	ladd
	stl	3
	ldlp	2
	ldlp	9
	ldlp	4
	call	@_fmul64
	ldlp	4
	ldlp	6
	call	@_refl64
	ldl	8
	stl	0
	.ldc	2
	ldlp	6
	ldlp	4
	call	@_r64op
	ldl	8
	stl	0
	.ldc	0
	ldlp	4
	ldlp	17
	call	@_r64op
L19:	ldl	11
	cj	@L21
	ldlp	17
	stl	0
	.ldc	1
	ldl	19
	ldnlp	16
	ldlp	9
	call	@_r64op
	ldl	9
	stl	17
	ldl	10
	stl	18
L21:	ldlp	17
	ldl	[x]
	.ldc	8
	move
	_asm_ajw(20)
	ret
#endif	/* T800 */
	#pragma	endasm
	}
