/*
 *	File:	cosh64.c
 *
 *	Implements T800/T414 64 bit floating point "cosh(x)".
 *
 *	Based on INMOS supplied code.  Modified by Logical Systems for correct
 *	ANSI "C" setting of "errno" in ERANGE/EDOM situations.
 */

#include	<inline.h>
#include	<math.h>
#include	<stddef.h>

#pragma	asm_expand			/* Recognize EDOM/ERANGE in "asm" */

double
cosh(double x)
	{
	#pragma	asm
#ifdef	T800
;
;	T800 64 bit version
;
	.ext	errno
	.ext	exp
	_asm_ajw(-9)
	ldlp	[x]
	fpldnldb
	fpnan
	stl	4
	ldlp	[x]
	fpldnldb
	fpuabs
	ldlp	7
	fpstnldb
	ldl	4
	cj	@L1
	ldlp	[x]
	ldlp	5
	.ldc	8
	move
	.ldc	EDOM			;Domain error (input is NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	j	@L4
	.align
data:	.dw	0x9708893b
	.dw	0x408633ce
	.dw	0x00000000
	.dw	0x7ff00000
	.dw	0x7b2737fa
	.dw	0x40325e4f
	.dw	0x00000000
	.dw	0x3fe62e60
	.dw	0xeb0202d5
	.dw	0x3eed0112
	.dw	0x00000000
	.dw	0x3ff00000
L1:	.ldc	data
	stl	[x]			;Re-use
	ldlp	7
	fpldnldb
	ldl	[x]
	fpldnldb
	fpgt
	cj	@L2
	ldl	[x]
	ldnlp	2
	ldlp	5
	.ldc	8
	move
	j	@L4
L2:	ldlp	7
	fpldnldb
	ldl	[x]
	ldnlp	4
	fpldnldb
	fpgt
	cj	@L3
	ldl	[x]
	ldnlp	6
	ldlp	7
	fpldnldb
	fpldnldb
	fpsub
	ldlp	0
	fpstnldb
	ldl	1
	ldl	0
#ifdef	STATIC_LINK
	ldl	[?slb]
#endif	/* STATIC_LINK */
	call	@exp
	ldlp	2
	fpstnldb
	ldlp	2
	ldl	[x]
	ldnlp	8
	fpldnldb
	fpldnlmuldb
	ldlp	2
	fpldnladddb
	ldlp	5
	fpstnldb
	j	@L4
L3:	ldl	8
	ldl	7
#ifdef	STATIC_LINK
	ldl	[?slb]
#endif	/* STATIC_LINK */
	call	@exp
	ldlp	2
	fpstnldb
	ldlp	2
	ldl	[x]
	ldnlp	10
	fpldnldb
	fpldnldb
	fpdiv
	ldlp	2
	fpldnladddb
	ldlp	0
	fpstnldb
	ldlp	0
	fpldnldb
	fpudivby2
	ldlp	5
	fpstnldb
L4:	ldlp	5
	fpldnldb
	_asm_ajw(9)
	ret
#else	/* T800 */
;
;	T414 64 bit version (from D700D).  NO attempt is made here to optimize
;	the OCCAM generated code (hope to get to this someday...)
;
	.ext	errno
	.ext	_FPstate
	.ext	_iexp64
	.ext	_rex64
	.ext	_r64op
	_asm_ajw(-16)
	.ldc	data
	stl	15
	ldlp	[x]
	ldlp	11
	.ldc	8
	move
	ldl	11
	stl	9
	ldl	12
	.ldc	2147483647
	and
	stl	10
	ldl	10
	.ldc	2146435072
	gt
	eqc	0
	cj	@L2
	ldl	10
	.ldc	2146435072
	diff
	eqc	0
	cj	@L1
	ldl	9
	mint
	xor
	mint
	gt
L1:	eqc	0
L2:	eqc	0
	cj	@L3
	ldl	11
	stl	7
	ldl	12
	stl	8
	ldl	7
	stl	13
	ldl	8
	stl	14
	.ldc	EDOM			;Domain error (input is NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	j	@L10
	.align
data:	.dw	0x00000000
	.dw	0x7ff00000
	.dw	0x00000000
	.dw	0x3fe62e60
	.dw	0xeb0202d5
	.dw	0x3eed0112
	.dw	0x00000000
	.dw	0x3ff00000
L3:	ldl	10
	.ldc	1082536910
	gt
	eqc	0
	cj	@L5
	ldl	10
	.ldc	1082536910
	diff
	eqc	0
	cj	@L4
	ldl	9
	mint
	xor
	.ldc	386435387
	gt
L4:	eqc	0
L5:	eqc	0
	cj	@L6
	ldl	15
	ldlp	13
	.ldc	8
	move
	.ldc	ERANGE			;Range error (input is too large)
	_asm_eval1(&errno);
	stnl	0			;Set errno to ERANGE
	j	@L10
L6:	ldl	10
	.ldc	1077042767
	gt
	eqc	0
	cj	@L8
	ldl	10
	.ldc	1077042767
	diff
	eqc	0
	cj	@L7
	ldl	9
	mint
	xor
	.ldc	-81315846
	gt
L7:	eqc	0
L8:	eqc	0
	cj	@L9
	ldl	9
	stl	7
	ldl	10
	stl	8
	ldl	15
	ldnlp	2
	stl	0
	.ldc	1
	ldlp	7
	ldlp	3
	call	@_r64op
	ldlp	3
	ldlp	5
	call	@_rex64
	ldl	15
	ldnlp	4
	stl	0
	.ldc	2
	ldlp	5
	ldlp	3
	call	@_r64op
	ldlp	3
	stl	0
	.ldc	0
	ldlp	5
	ldlp	13
	call	@_r64op
	j	@L10
L9:	ldl	9
	stl	7
	ldl	10
	stl	8
	ldlp	7
	ldlp	5
	call	@_rex64
	ldlp	5
	stl	0
	.ldc	3
	ldl	15
	ldnlp	6
	ldlp	3
	call	@_r64op
	ldlp	3
	stl	0
	.ldc	0
	ldlp	5
	ldlp	1
	call	@_r64op
	.ldc	-1
	ldlp	1
	ldlp	13
	call	@_iexp64
L10:	ldlp	13
	.ldc	_FPstate		;Addr of "soft" FAreg
	.ldc	8
	move
	_asm_ajw(16)
	ret
#endif	/* T800 */
	#pragma	endasm
	}
