/*
 *	env.c
 *
 *	Runtime environment information for the Transputer.
 *
 *	Copyright 1987-1991 by Logical Systems.
 */

#include	<conc.h>

Channel		*_boot_chan_in;		/* Input boot channel address */
Channel		*_boot_chan_out;	/* Output boot channel address */

Channel		*_host_chan_in;		/* Host services input channel */
Channel		*_host_chan_out;	/* Host services output channel */

void		(*_HostIn)(Channel *,void *,int);	/* Host input func */
void		(*_HostOut)(Channel *,void *,int);	/* Host output func */

int		_node_number;		/* User supplied node # */

#define		NOTMALLOC
#include	"../malloc.c"		/* Dynamic memory include info */

#pragma	asm_expand			/* Recognize PREVINUSE etc. in "asm" */

#pragma	asm
	.pub	_freelist		;Dynamic memory free storage list
	.pub	_heapstart		;Pointer to heap start
	.pub	_heapend		;Pointer to end of heap

	.align
_freelist
	.dw	_dummy			;Point to dummy list element
_heapstart
	.dw	_hs
;
;	WARNING: The heap size MUST be a multiple of ALIGNMENT
;
_heapend
#ifdef	T212
	.dw	_hs + (ALIGNMENT * 0x2000)	;Default to 32K of heap
#else	/* !T212 */
	.dw	_hs + (ALIGNMENT * 0x8000)	;Default to 128K of heap
#endif	/* T212 */
_dummy
	.dw	0			;Zero length
	.dw	_dummy			;Points to itself
	.dw	_dummy

	.mod	254			;Heap load region
	.align
_hs	.dw	(THISINUSE | PREVINUSE)	;Initial word in heap
#pragma	endasm
