/*
 *	File:	exp64.c
 *
 *	Implements T800/T414 64 bit floating point "exp(x)".
 *
 *	Based on INMOS supplied code.  Modified by Logical Systems for correct
 *	ANSI "C" setting of "errno" in ERANGE/EDOM situations.
 */

#include	<inline.h>
#include	<math.h>
#include	<stddef.h>

#pragma	asm_expand			/* Recognize EDOM/ERANGE in "asm" */

double
exp(double x)
	{
	#pragma	asm
#ifdef	T800
;
;	T800 64 bit version
;
	.ext	_argr
	.ext	errno
	.ext	_scale
	_asm_ajw(-19)
	.ldc	data
	stl	18
	.ldc	0
	stl	17
	ldlp	[x]
	fpldnldb
	fpnan
	stl	17
	ldlp	[x]
	fpldnldb
	fpuabs
	ldlp	15
	fpstnldb
	ldl	17
	cj	@L1
	ldlp	[x]
	ldlp	13
	.ldc	8
	move
	.ldc	EDOM			;Domain error (input is NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	j	@L6
	.align
data:	.dw	0xff08893b
	.dw	0x40862e42
	.dw	0x00000000
	.dw	0x7ff00000
	.dw	0x00000000
	.dw	0x40874c00
	.dw	0x00000000
	.dw	0x3c900000
	.dw	0x00000000
	.dw	0x3ff00000
	.dw	0xfefa39ef
	.dw	0x3fe62e42
	.dw	0x3b39803f
	.dw	0x3c7abc9e
	.dw	0x2ae6921f
	.dw	0x3f008b44
	.dw	0xf22a12a6
	.dw	0x3f7f074b
	.dw	0x00000000
	.dw	0x3fd00000
	.dw	0x0ce50456
	.dw	0x3ea93363
	.dw	0x5c28d4e0
	.dw	0x3f44af0c
	.dw	0x51dfd9ff
	.dw	0x3fad1728
	.dw	0x00000000
	.dw	0x3fe00000
L1:	ldlp	[x]
	fpldnldb
	ldl	18
	fpldnldb
	fpgt
	cj	@L2
	ldl	18
	ldnlp	2
	ldlp	13
	.ldc	8
	move
	.ldc	ERANGE			;Input too large, signal range error
	_asm_eval1(&errno);
	stnl	0			;Set errno to ERANGE
	j	@L6
L2:	fpldzerodb
	ldlp	[x]
	fpldnldb
	fpgt
	cj	@L3
	ldlp	15
	fpldnldb
	ldl	18
	ldnlp	4
	fpldnldb
	fpgt
	cj	@L3
	fpldzerodb
	ldlp	13
	fpstnldb
	j	@L6
L3:	ldl	18
	ldnlp	6
	fpldnldb
	ldlp	15
	fpldnldb
	fpgt
	cj	@L5
	ldl	18
	ldnlp	8
	ldlp	13
	.ldc	8
	move
	j	@L6
L5:	.ldc	0
	stl	7
	ldl	18
	ldnlp	10
	ldlp	5
	.ldc	8
	move
	ldl	18
	ldnlp	12
	ldlp	3
	.ldc	8
	move
	ldlp	3
	stl	2
	ldlp	5
	stl	1
	ldlp	[x]
	stl	0
	ldlp	11
	ldlp	8
	ldlp	7
	call	@_argr
	ldlp	11
	ldlp	11
	fpldnldb
	fpldnlmuldb
	ldlp	6
	fpstnldb
	ldl	18
	ldnlp	14
	ldlp	6
	fpldnldb
	fpldnlmuldb
	ldl	18
	ldnlp	16
	fpldnladddb
	ldlp	6
	fpldnlmuldb
	ldl	18
	ldnlp	18
	fpldnladddb
	ldlp	11
	fpldnlmuldb
	ldlp	4
	fpstnldb
	ldlp	4
	fpldnldb
	ldl	18
	ldnlp	20
	ldlp	6
	fpldnldb
	fpldnlmuldb
	ldl	18
	ldnlp	22
	fpldnladddb
	ldlp	6
	fpldnlmuldb
	ldl	18
	ldnlp	24
	fpldnladddb
	ldlp	6
	fpldnlmuldb
	ldl	18
	ldnlp	26
	fpldnladddb
	ldlp	4
	fpldnldb
	fpsub
	fpdiv
	ldl	18
	ldnlp	26
	fpldnladddb
	ldlp	9
	fpstnldb
	ldl	8
	adc	1
	ldlp	9
	ldlp	13
	call	@_scale
L6:	ldlp	13
	fpldnldb
	_asm_ajw(19)
	ret
#else	/* T800 */
;
;	T414 64 bit version (from D700D).  NO attempt is made here to optimize
;	the OCCAM generated code (hope to get to this someday...)
;
	.ext	errno
	.ext	_fdiv64
	.ext	_fix64
	.ext	_fmul64
	.ext	_FPstate
	.ext	_refl64
	.ext	_r64fei
	.ext	_r64op
	.ext	_r64tei
	.ext	_shr64
	_asm_ajw(-27)
	.ldc	data
	stl	26
	ldlp	[x]
	ldlp	22
	.ldc	8
	move
	ldl	22
	stl	20
	ldl	23
	.ldc	2147483647
	and
	stl	21
	ldl	21
	.ldc	2146435072
	gt
	eqc	0
	cj	@L2
	ldl	21
	.ldc	2146435072
	diff
	eqc	0
	cj	@L1
	ldl	20
	mint
	xor
	mint
	gt
L1:	eqc	0
L2:	eqc	0
	cj	@L3
	ldlp	[x]
	ldlp	24
	.ldc	8
	move
	.ldc	EDOM			;Domain error (input is NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	j	@L20
	.align
data:	.dw	0x00000000
	.dw	0x7ff00000
	.dw	0x00000000
	.dw	0x3ff00000
	.dw	0x652b82fe
	.dw	0x3ff71547
	.dw	0x00000000
	.dw	0x3fe63000
	.dw	0x5c610ca8
	.dw	0xbf2bd010
	.dw	0x237ac6e2
	.dw	0x00008a95
	.dw	0x6fde3807
	.dw	0x00103f99
	.dw	0x00000000
	.dw	0x00000000
L3:	ldl	23
	.ldc	1082535490
	gt
	eqc	0
	cj	@L5
	ldl	23
	.ldc	1082535490
	diff
	eqc	0
	cj	@L4
	ldl	22
	mint
	xor
	.ldc	2131265851
	gt
L4:	eqc	0
L5:	eqc	0
	cj	@L6
	ldl	26
	ldlp	24
	.ldc	8
	move
	.ldc	ERANGE			;Input too large, signal range error
	_asm_eval1(&errno);
	stnl	0			;Set errno to ERANGE
	j	@L20
L6:	ldl	21
	.ldc	1082606469
	gt
	eqc	0
	cj	@L8
	ldl	21
	.ldc	1082606469
	diff
	eqc	0
	cj	@L7
	ldl	20
	mint
	xor
	.ldc	-999460400
	gt
L7:	eqc	0
L8:	eqc	0
	cj	@L9
	.ldc	0
	stl	24
	.ldc	0
	stl	25
	j	@L20
L9:	.ldc	1016070144
	ldl	21
	gt
	eqc	0
	cj	@L11
	.ldc	1016070144
	ldl	21
	diff
	eqc	0
	cj	@L10
	mint
	ldl	20
	mint
	xor
	gt
L10:	eqc	0
L11:	eqc	0
	cj	@L12
	ldl	26
	ldnlp	2
	ldlp	24
	.ldc	8
	move
	j	@L20
L12:	ldl	26
	ldnlp	4
	stl	0
	.ldc	2
	ldlp	[x]
	ldlp	16
	call	@_r64op
	ldlp	16
	.ldc	1
	ldlp	18
	call	@_r64tei
	ldlp	18
	.ldc	1
	ldlp	16
	call	@_r64fei
	ldl	26
	ldnlp	6
	stl	0
	.ldc	2
	ldlp	16
	ldlp	12
	call	@_r64op
	ldlp	12
	stl	0
	.ldc	1
	ldlp	[x]
	ldlp	10
	call	@_r64op
	ldl	26
	ldnlp	8
	stl	0
	.ldc	2
	ldlp	16
	ldlp	12
	call	@_r64op
	ldlp	12
	stl	0
	.ldc	1
	ldlp	10
	ldlp	14
	call	@_r64op
	ldlp	14
	ldlp	12
	call	@_fix64
	ldlp	12
	ldlp	12
	ldlp	10
	call	@_fmul64
	ldl	26
	ldnlp	10
	ldlp	10
	ldlp	6
	call	@_fmul64
	.ldc	0
	ldl	6
	.ldc	2107619073
	lsum
	stl	2
	ldl	7
	.ldc	14911267
	ladd
	stl	3
	ldlp	2
	ldlp	10
	ldlp	4
	call	@_fmul64
	.ldc	0
	ldl	4
	.ldc	-65
	lsum
	stl	6
	ldl	5
	.ldc	536870911
	ladd
	stl	7
	ldlp	6
	ldlp	12
	ldlp	8
	call	@_fmul64
	ldl	8
	stl	12
	ldl	9
	stl	13
	ldl	26
	ldnlp	12
	ldlp	10
	ldlp	8
	call	@_fmul64
	.ldc	0
	ldl	8
	.ldc	1351904427
	lsum
	stl	4
	ldl	9
	.ldc	119301020
	ladd
	stl	5
	ldlp	4
	ldlp	10
	ldlp	6
	call	@_fmul64
	ldl	6
	stl	4
	.ldc	0
	ldl	7
	.ldc	1073741824
	ladd
	stl	5
	.ldc	0
	ldl	4
	ldl	12
	ldiff
	stl	6
	ldl	5
	ldl	13
	lsub
	stl	7
	ldlp	6
	ldlp	12
	ldlp	8
	call	@_fdiv64
	ldl	8
	stl	6
	.ldc	0
	ldl	9
	.ldc	1073741824
	ladd
	stl	7
	ldlp	6
	ldlp	24
	call	@_refl64
	ldlp	24
	stl	13
	ldl	13
	ldnl	1
	ldl	13
	ldnl	0
	.ldc	52
	lshr
	stl	9
	stl	10
	.ldc	0
	ldl	18
	.ldc	1
	lsum
	stl	7
	ldl	19
	.ldc	0
	ladd
	stl	8
	.ldc	0
	ldl	9
	ldl	7
	lsum
	stl	11
	ldl	10
	ldl	8
	ladd
	stl	12
	ldl	12
	.ldc	0
	gt
	eqc	0
	cj	@L14
	ldl	12
	eqc	0
	cj	@L13
	ldl	11
	mint
	xor
	mint
	gt
L13:	eqc	0
L14:	cj	@L19
	.ldc	1
	ldl	11
	diff
	stl	10
	ldl	26
	ldnlp	14
	stl	0
	ldl	10
	stl	1
	ldl	13
	ldnl	0
	stl	4
	ldl	13
	ldnl	1
	.ldc	1048575
	and
	stl	5
	ldl	4
	stl	2
	ldl	5
	.ldc	1048576
	or
	stl	3
	ldlp	2
	ldlp	8
	ldlp	6
	call	@_shr64
	ldlp	6
	ldl	13
	.ldc	8
	move
	.ldc	0
	ldl	9
	gt
	eqc	0
	cj	@L15
	j	@L17
L15:	ldl	8
	ldl	9
	mint
	diff
	or
	eqc	0
	cj	@L16
	ldl	13
	ldnl	0
	.ldc	1
	and
	stl	6
	.ldc	0
	stl	7
	ldl	6
	.ldc	1
	diff
	ldl	7
	or
	eqc	0
	cj	@L17
L16:	.ldc	0
	ldl	13
	ldnl	0
	.ldc	1
	lsum
	stl	6
	ldl	13
	ldnl	1
	.ldc	0
	ladd
	stl	7
	ldlp	6
	ldl	13
	.ldc	8
	move
L17:	j	@L20
L19:	ldl	13
	ldnl	0
	stl	7
	ldl	13
	ldnl	1
	.ldc	1048575
	and
	stl	8
	ldl	12
	ldl	11
	.ldc	52
	lshl
	stl	5
	stl	6
	ldl	7
	ldl	5
	or
	stl	9
	ldl	8
	ldl	6
	or
	stl	10
	ldlp	9
	ldl	13
	.ldc	8
	move
L20:	ldlp	24
	.ldc	_FPstate		;Addr of "soft" FAreg
	.ldc	8
	move
	_asm_ajw(27)
	ret
#endif	/* T800 */
	#pragma	endasm
	}
