/*
 *	File:	fabs32.c
 *
 *	Implements T800/T414 32 bit "fabsf(x)/fabs(x)".
 *
 *	Based on INMOS supplied code.  Modified by Logical Systems for correct
 *	ANSI "C" setting of "errno" in ERANGE/EDOM situations.
 */

#include	<inline.h>
#include	<math.h>
#include	<stddef.h>

#pragma	asm_expand			/* Recognize EDOM/ERANGE in "asm" */

#undef	fabs
#undef	fabsf

float
fabsf(float x)
	{
	#pragma	asm
#ifdef	DOUBLE32
	.pub	fabs
fabs:
#endif	DOUBLE32

#ifdef	T800
;
;	T800 32 bit version
;
	.ext	errno
	ldlp	[x]
	fpldnlsn
	fpnan
	cj	@L1			;jump if OK
	.ldc	EDOM			;Domain error (input is NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	ret
L1	fpuabs
#else	/* T800 */
;
;	T414 32 bit version
;
	.ext	?SN32TOFAREG
	.ext	errno
	ldl	[x]			;Get #
	.ldc	0x7FFFFFFF
	and				;Mask off sign
	stl	[x]			;Absolute value
	.ldc	0			;Initial value for B
	ldl	[x]
	unpacksn			;Check for NaN's
	diff				;Toss A
	stl	3			;Toss B
	eqc	3			;A is operand "type"
	cj	@L1			;Jump if not NaN
	.ldc	EDOM			;Domain error (input is NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
L1
	ldl	[x]
	call	@?SN32TOFAREG		;Store 32 bit fp in A into FAreg
#endif	/* T800 */
	#pragma	endasm
	}
