/*
 *	File:	fabs64.c
 *
 *	Implements T800/T414 64 bit "fabs(x)".
 *
 *	Based on INMOS supplied code.  Modified by Logical Systems for correct
 *	ANSI "C" setting of "errno" in ERANGE/EDOM situations.
 */

#include	<inline.h>
#include	<math.h>
#include	<stddef.h>

#pragma	asm_expand			/* Recognize EDOM/ERANGE in "asm" */

#undef	fabs

double
fabs(double x)
	{
	#pragma	asm
#ifdef	T800
;
;	T800 64 bit version
;
	.ext	errno
	ldlp	[x]
	fpldnldb
	fpnan
	cj	@L1			;jump if OK
	.ldc	EDOM			;Domain error (input is NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	ret
L1	fpuabs
#else	/* T800 */
;
;	T414 64 bit version
;
	.ext	errno
	.ext	_FPstate
	ldl	[x]+1			;Get high order word of #
	.ldc	0x7FFFFFFF
	and				;Mask off sign bit
	stl	[x]+1			;Update high order word
	ldl	[x]+1
	.ldc	(0x7FF00000 - 1)	;See if NaN or Inf
	gt
	cj	@L1			;Jump if not a NaN
	.ldc	EDOM			;Domain error (input is NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
L1
	ldlp	[x]			;Address of return value
	.ldc	_FPstate		;Destination address
	.ldc	8			;8 bytes worth of it
	move
#endif	/* T800 */
	#pragma	endasm
	}
