/*
 *	File:	fmod32.c
 *
 *	Implements T800/T414 32 bit floating point "fmodf(x,y)/fmod(x,y)".
 *
 *	Based on INMOS supplied code.  Modified by Logical Systems for correct
 *	ANSI "C" setting of "errno" in ERANGE/EDOM situations.
 */

#include	<inline.h>
#include	<math.h>
#include	<stddef.h>

#pragma	asm_expand			/* Recognize EDOM/ERANGE in "asm" */

float
fmodf(float x,float y)
	{
	#pragma	asm
#ifdef	DOUBLE32
	.pub	fmod
fmod:
#endif	DOUBLE32

#ifdef	T800
;
;	T800 32 bit version
;
	.ext	errno
	ldlp	[y]
	ldlp	[x]
	fpldnlsn
	fpnotfinite
	stl	[x]
	fpldnlsn
	fpnotfinite
	cj	@L2			;Jump if "y" not NaN or infinite
L0:	fpadd				;Add to propagate NaN's
L1:	.ldc	EDOM			;Domain error (input was NaN probably)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	ret				;Return NaN as result
	.align
unstable
	.dw	0x7F800008		;"unstable" NaN
L2:	ldl	[x]			;Was "x" Nan or infinite?
	cj	@L3			;Nope
	.ldc	0
	cj	@L0			;Jump since "x" was NaN or infinite
L3:	fpdiv
	fpnotfinite
	cj	@L4			;Jump if result looks OK
	.ldc	unstable		;Result will be "unstable" NaN
	fpldnlsn
	.ldc	0
	cj	@L1			;Jump if result is NaN
L4:	fpdup
	fpurz
	fpint
	fpsub
	ldlp	[y]
	fpldnlmulsn
#else	/* T800 */
;
;	T414 32 bit version
;
#endif	/* T800 */
	#pragma	endasm
	}
