/*
 *	fnsstart.c
 *
 *	Handle initialization prior to calling "main".  This file is similar in
 *	function to the "fstart.c" file except this file assumes the CIO server
 *	will not be used with this program and avoids dragging the server
 *	interface library in.
 *
 *	Modified from "nsstart.c" by Scott Lloyd of Alta Technology.
 *
 *	Copyright 1987-1991 by Alta Technology and Logical Systems.
 *
 *	WARNING:  THE "_ns_fmain" ROUTINE NEEDS MODIFICATION FOR USE WITH THE
 *	"static link" GLOBAL DATA MODEL (IT MUST SETUP THE INITIAL VALUE)!
 */

#include <inline.h>
#include "flood.h"

#pragma	asm
	.ext	main			;Main program entry point
	.ext	_boot_chan_in		;Input boot channel address
	.ext	_boot_chan_out		;Output boot channel address
	.ext	ChanIn			;Read input bytes from channel
	.ext	ChanOut			;Write output bytes to channel
	.ext	_host_chan_in		;Host services input channel
	.ext	_host_chan_out		;Host services outptu channel
	.ext	_HostIn			;Read bytes from host services channel
	.ext	_HostOut		;Write bytes to host services channel
	.ext	_node_number		;User supplied network node #
	.ext	_ns_exit		;Stop process in place
#pragma	endasm

typedef struct {
	int nodeid;
	int memory;
	int minint;
	int bootin;
	int bootout[4];
	int entryp;
	int worksp;
	int loadst;
	int loadad;
} NDST;

/*
 *	_ns_fmain
 *
 *	Non-Server version of "_fmain".  MUST BE MODIFIED FOR USE WITH THE
 *	STATIC LINK DATA MODEL (THE INITIAL VALUE OF THE STATIC LINK MUST BE
 *	SET AND THE DATA ACCESSES MUST BE CHANGED FROM ".ldc" TO THE
 *	APPROPRIATE TECHNIQUE).
 */
void
_ns_fmain(NDST *info)
	{
	;
	#pragma	asm
	_asm_eval1(info->bootin);	;Get input channel address
	.ldc	_boot_chan_in
	stnl	0			;Save input channel address
	_asm_eval1(info->bootin);	;Get input channel address
	ldnlp	-4			;Compute output channel address
	.ldc	_boot_chan_out
	stnl	0			;Save output channel address
	_asm_eval1(info->nodeid);	;Processor node #
	.ldc	_node_number
	stnl	0			;Save processor node #
	_asm_eval1(info->nodeid);
	eqc	1			;If node #1
	cj	@main1			;Jump if not
;
;	Set up host channels and functions
;
	_asm_eval1(info->bootin);	;Get input channel address
	.ldc	_host_chan_in
	stnl	0			;Save host input channel address
	_asm_eval1(info->bootin);	;Get input channel address
	ldnlp	-4			;Compute output channel address
	.ldc	_host_chan_out
	stnl	0			;Save host output channel address
	.ldc	ChanIn			;Address of "ChanIn" function
	.ldc	_HostIn			;Dup into "HostIn" function pointer
	stnl	0
	.ldc	ChanOut			;Address of "ChanOut" function
	.ldc	_HostOut		;Dup into "HostOut" function pointer
	stnl	0
	j	@main2
main1:
;
;	Set up host functions to kill process
;
	.ldc	killp			;Address of killp function
	.ldc	_HostIn			;Dup into "HostIn" function pointer
	stnl	0
	.ldc	killp			;Address of killp function
	.ldc	_HostOut		;Dup into "HostOut" function pointer
	stnl	0
main2:
;
;	Dummy up the argv/argc stuff.
;
	ajw	-3			;three words of temp space
	.ldc	0
	stl	2			;*argv[0] value
	ldlp	2
	stl	1			;argv[0] pointer
;
;	Call main
;
	ldl	[info]+3		;Pass info as fourth param.
	stl	0
	.ldc	0			;NULL env ptr
	ldlp	1			;ARGV
	.ldc	1			;ARGC
	call	@main
killp:
	stopp
	#pragma	endasm
	}
