/*
 *	File:	log1032.c
 *
 *	Implements T800/T414 32 bit floating point "log10f(x)/log10(x)".
 *
 *	Based on INMOS supplied code.
 */

#include	<inline.h>
#include	<math.h>

float
log10f(float x)
	{
	#pragma	asm
#ifdef	DOUBLE32
	.pub	log10
log10:
#endif	DOUBLE32

#ifdef	T800
;
;	T800 32 bit version
;
	.ext	logf
	_asm_ajw(-3);
	.ldc	data
	stl	6
	.ldc	0
	stl	0
	ldl	[x]
#ifdef	STATIC_LINK
	ldl	[?slb]
#endif	/* STATIC_LINK */
	call	@logf
	ldlp	1
	fpstnlsn
	ldlp	1
	fpldnlsn
	fpnan
	stl	0
	ldl	0
	cj	@L1
	ldl	1
	stl	2
	j	@L2
	.align
data:	.dw	0x3ede5bd9
L1:	ldlp	1
	ldl	6
	fpldnlsn
	fpldnlmulsn
	ldlp	2
	fpstnlsn
L2:	ldlp	2
	fpldnlsn
	_asm_ajw(3);
#else	/* T800 */
;
;	T414 32 bit version
;
#endif	/* T800 */
	#pragma	endasm
	}
