/*
 *	File:	modf64.c
 *
 *	Implements T800/T414 64 bit floating point "modf()".
 *
 *	Copyright 1987,1988,1989 by Logical Systems.
 */

#include	<inline.h>
#include	<math.h>

double
modf(double x,double *y)
	{
	#pragma	asm
#ifdef	T800
;
;	T800 64 bit version
;
	ldlp	[x]			;Get address of "value"
	fpldnldb			;Load value
	fpdup				;Save a copy
	fpurz				;Round towards zero
	fpint				;Compute integer part
	fpdup				;Save a copy
	ldl	[y]			;Get address of "iptr"
	fpstnldb			;Store integral component
	fpsub				;Compute fractional component
	ret
#else	/* T800 */
;
;	T414 32 bit version
;
	.ext	_FPstate
	.ext	_r64fei
	.ext	_r64op
	.ext	_r64tei
	_asm_ajw(-5)
	ldlp	[x]
	.ldc	0			;Truncate result
	ldlp	1
	call	@_r64tei		;Convert to 64 bit integer
	ldlp	1			;Temp storage
	.ldc	0			;Truncate result
	ldlp	3
	call	@_r64fei		;Convert back to double
	ldl	3
	ldl	[y]			;Store integral part away
	stnl	0
	ldl	4
	ldl	[y]
	stnl	1
	ldlp	3			;Truncated version of "x"
	stl	0
	.ldc	1			;We need a subtract
	ldlp	[x]			;Non-truncated version of "x"
	.ldc	_FPstate
	call	@_r64op
	_asm_ajw(5)
	ret
#endif	/* T800 */
	#pragma	endasm
	}
