/*
 *	nsstart.c
 *
 *	Handle initialization prior to calling "main".  This file is similar in
 *	function to the "start.c" file except this file assumes the CIO server
 *	will not be used with this program and avoids dragging the server
 *	interface library in.
 *
 *	Copyright 1988-1991 by Logical Systems.
 *
 *	WARNING:  THE "_ns_main" ROUTINE NEEDS MODIFICATION FOR USE WITH THE
 *	"static link" GLOBAL DATA MODEL (IT MUST SETUP THE INITIAL VALUE)!
 */

#include	<inline.h>

#pragma	asm
	.ext	main			;Main program entry point
	.ext	_boot_chan_in		;Input boot channel address
	.ext	_boot_chan_out		;Output boot channel address
	.ext	ChanIn			;Read input bytes from channel
	.ext	ChanOut			;Write output bytes to channel
	.ext	_host_chan_in		;Host services input channel
	.ext	_host_chan_out		;Host services outptu channel
	.ext	_HostIn			;Read bytes from host services channel
	.ext	_HostOut		;Write bytes to host services channel
	.ext	_node_number		;User supplied network node #
	.ext	_ns_exit		;Stop process in place
#pragma	endasm

/*
 *	_ns_main
 *
 *	Non-Server version of "_main".  MUST BE MODIFIED FOR USE WITH THE
 *	STATIC LINK DATA MODEL (THE INITIAL VALUE OF THE STATIC LINK MUST BE
 *	SET AND THE DATA ACCESSES MUST BE CHANGED FROM ".ldc" TO THE
 *	APPROPRIATE TECHNIQUE).
 */
void
_ns_main(void)
	{
	#pragma	asm
	ajw	-2			;A bit of temp space
;
;	At this point WS(1) is the user supplied node #.
;
;	Input channel address is initially in "C"
;
	or
	stl	0			;Input channel address in "A"
	stl	0			;Save for a bit
	ldl	0
	.ldc	_boot_chan_in
	stnl	0			;Save input boot channel address
	ldl	0
	.ldc	_host_chan_in
	stnl	0			;Dup into host input channel address
	.ldc	ChanIn			;Address of "ChanIn" function
	.ldc	_HostIn			;Dup into "HostIn" function pointer
	stnl	0
	.ldc	4
	bcnt				;Areg will be 8 for T2, 16 for T4/T8
	ldl	0			;Get input channel address
	xor				;Compute output channel address
	stl	0			;Save for a bit
	ldl	0
	.ldc	_boot_chan_out
	stnl	0			;Save output boot channel address
	ldl	0
	.ldc	_host_chan_out
	stnl	0			;Dup into host output channel address
	.ldc	ChanOut			;Address of "ChanOut" function
	.ldc	_HostOut		;Dup into "HostOut" function pointer
	stnl	0
	ldl	1			;Processor node #
	.ldc	_node_number
	stnl	0			;Save processor node #
;
;	If virtual channel support has been requested ("_node_number" == 0),
;	just quit as this startup code isn't intended to handle them.
;
	ldl	1
	cj	@main1
;
;	Dummy up the argv/argc stuff.
;
	ldlp	1
	stl	0			;argv[0] value
	.ldc	0
	stl	1			;argv[0] points to this
	.ldc	0			;Environment pointer
	ldlp	0			;ARGV
	.ldc	1			;ARGC
	call	@main
main1
	call	_ns_exit
	#pragma	endasm
	}
