/*
 *	rcomm.c
 *
 *	Reliable communication primitives for the Transputer.
 *
 *	Based on the Transputer concurrency function library designed by
 *	Jeffrey Mock of PIXAR (Version 2).  This implementation by Scott Lloyd
 *	of CSA.  Modifications by Kirk Bailey of Logical Systems.
 *
 *	Copyright 1987-1991 by Computer System Architects and Logical Systems.
 */

#include	<conc.h>

int
ChanInChanFail(Channel *chan,void *p,int cnt,Channel *failchan)
	{
	#pragma asm
; 15 total workspace slots are needed (ie. AJW -12 and 3 more)
;- - - - - - - - - - - Init and Startup - - - - - - - - - - -
	AJW	-4
	MINT
	STL	3			;Completed
	.LDC	2
	STL	1			;Processes to end
	.LDC	IC8-IC1
	LDPI
IC1
	STL	0			;Next iptr
	.LDC	IC3-IC2
	LDLP	-2
	STARTP				;Start monitor process
;- - - - - - - - - - - Communication Process - - - - - - - - - - -
IC2
	AJW	-8
	LDL	14			;p
	LDL	13			;chan
	LDL	15			;cnt
	IN
	LDLP	11			;Completed
	.LDC	0
	OUTWORD
	LDLP	8			;Next wsp
	ENDP
;- - - - - - - - - - - Monitor Process - - - - - - - - - - -
IC3
	ALT
	LDLP	5			;Completed
	.LDC	1
	ENBC
	LDL	10			;Failchan
	.LDC	1
	ENBC
	ALTWT
	LDLP	5			;Completed
	.LDC	1
	.LDC	IC6-IC4
	DISC
	LDL	10			;failchan
	.LDC	1
	.LDC	0
	DISC
	ALTEND
IC4
	LDLP	1			;SIG
	LDL	10			;failchan
	.LDC	1
	BCNT				;len
	IN
	LDL	7			;chan
	RESETCH
	STL	0
	LDL	0
	MINT
	DIFF
	CJ	@IC5
	LDL	0
	RUNP
IC5
	LDLP	1			;SIG
	LDLP	5			;Completed
	.LDC	1
	BCNT
	IN
	.LDC	1			;TRUE
	STL	4			;ok
	J	@IC7
IC6
	LDLP	1			;SIG
	LDLP	5			;Completed
	.LDC	1
	BCNT
	IN
	.LDC	0			;FALSE
	STL	4			;ok
IC7
	LDLP	2			;Next wsp
	ENDP
;- - - - - - - - - - - Join and Return - - - - - - - - - - -
IC8
	LDL	2
	AJW	4
	#pragma endasm
	}

int
ChanInTimeFail(Channel *chan,void *p,int cnt,int time)
	{
	#pragma asm
; 15 total workspace slots are needed (ie. AJW -12 and 3 more)
;- - - - - - - - - - - Init and Startup - - - - - - - - - - -
	AJW	-4
	MINT
	STL	3			;Completed
	.LDC	2
	STL	1			;Processes to end
	.LDC	IT8-IT1
	LDPI
IT1
	STL	0			;Next iptr
	.LDC	IT3-IT2
	LDLP	-2
	STARTP				;Start monitor process
;- - - - - - - - - - - Communication Process - - - - - - - - - - -
IT2
	AJW	-8
	LDL	14			;p
	LDL	13			;chan
	LDL	15			;cnt
	IN
	LDLP	11			;Completed
	.LDC	0
	OUTWORD
	LDLP	8			;Next wsp
	ENDP
;- - - - - - - - - - - Monitor Process - - - - - - - - - - -
IT3
	TALT
	LDLP	5			;Completed
	.LDC	1
	ENBC
	LDL	10			;time
	.LDC	1
	ENBT
	TALTWT
	LDLP	5			;Completed
	.LDC	1
	.LDC	IT6-IT4
	DISC
	LDL	10			;time
	.LDC	1
	.LDC	0
	DIST
	ALTEND
IT4
	LDL	7			;chan
	RESETCH
	STL	0
	LDL	0
	MINT
	DIFF
	CJ	@IT5
	LDL	0
	RUNP
IT5
	LDLP	1			;SIG
	LDLP	5			;Completed
	.LDC	1
	BCNT				;len
	IN
	.LDC	1			;TRUE
	STL	4			;ok
	J	@IT7
IT6
	LDLP	1			;SIG
	LDLP	5			;Completed
	.LDC	1
	BCNT				;len
	IN
	.LDC	0			;FALSE
	STL	4			;ok
IT7
	LDLP	2			;Next wsp
	ENDP
;- - - - - - - - - - - Join and Return - - - - - - - - - - -
IT8
	LDL	2
	AJW	4
	#pragma endasm
	}

int
ChanOutChanFail(Channel *chan,void *p,int cnt,Channel *failchan)
	{
	#pragma asm
; 15 total workspace slots are needed (ie. AJW -12 and 3 more)
;- - - - - - - - - - - Init and Startup - - - - - - - - - - -
	AJW	-4
	MINT
	STL	3			;Completed
	.LDC	2
	STL	1			;Processes to end
	.LDC	OC8-OC1
	LDPI
OC1
	STL	0			;Next iptr
	.LDC	OC3-OC2
	LDLP	-2
	STARTP				;Start monitor process
;- - - - - - - - - - - Communication Process - - - - - - - - - - -
OC2
	AJW	-8
	LDL	14			;p
	LDL	13			;chan
	LDL	15			;cnt
	OUT
	LDLP	11			;Completed
	.LDC	0
	OUTWORD
	LDLP	8			;Next wsp
	ENDP
;- - - - - - - - - - - Monitor Process - - - - - - - - - - -
OC3
	ALT
	LDLP	5			;Completed
	.LDC	1
	ENBC
	LDL	10			;failchan
	.LDC	1
	ENBC
	ALTWT
	LDLP	5			;Completed
	.LDC	1
	.LDC	OC6-OC4
	DISC
	LDL	10			;failchan
	.LDC	1
	.LDC	0
	DISC
	ALTEND
OC4
	LDLP	1			;SIG
	LDL	10			;failchan
	.LDC	1
	BCNT				;len
	IN
	LDL	7			;chan
	RESETCH
	STL	0
	LDL	0
	MINT
	DIFF
	CJ	@OC5
	LDL	0
	RUNP
OC5
	LDLP	1			;SIG
	LDLP	5			;Completed
	.LDC	1
	BCNT				;len
	IN
	.LDC	1			;TRUE
	STL	4			;ok
	J	@OC7
OC6
	LDLP	1			;SIG
	LDLP	5			;Completed
	.LDC	1
	BCNT				;len
	IN
	.LDC	0			;FALSE
	STL	4			;ok
OC7
	LDLP	2			;Next wsp
	ENDP
;- - - - - - - - - - - Join and Return - - - - - - - - - - -
OC8
	LDL	2
	AJW	4
	#pragma endasm
	}

int
ChanOutTimeFail(Channel *chan,void *p,int cnt,int time)
	{
	#pragma asm
; 15 total workspace slots are needed (ie. AJW -12 and 3 more)
;- - - - - - - - - - - Init and Startup - - - - - - - - - - -
	AJW	-4
	MINT
	STL	3			;Completed
	.LDC	2
	STL	1			;Processes to end
	.LDC	OT8-OT1
	LDPI
OT1
	STL	0			;Next iptr
	.LDC	OT3-OT2
	LDLP	-2
	STARTP				;Start monitor process
;- - - - - - - - - - - Communication Process - - - - - - - - - - -
OT2
	AJW	-8
	LDL	14			;p
	LDL	13			;chan
	LDL	15			;cnt
	OUT
	LDLP	11			;Completed
	.LDC	0
	OUTWORD
	LDLP	8			;Next wsp
	ENDP
;- - - - - - - - - - - Monitor Process - - - - - - - - - - -
OT3
	TALT
	LDLP	5			;Completed
	.LDC	1
	ENBC
	LDL	10			;Time
	.LDC	1
	ENBT
	TALTWT
	LDLP	5			;Completed
	.LDC	1
	.LDC	OT6-OT4
	DISC
	LDL	10			;Time
	.LDC	1
	.LDC	0
	DIST
	ALTEND
OT4
	LDL	7			;Chan
	RESETCH
	STL	0
	LDL	0
	MINT
	DIFF
	CJ	@OT5
	LDL	0
	RUNP
OT5
	LDLP	1			;SIG
	LDLP	5			;Completed
	.LDC	1
	BCNT				;len
	IN
	.LDC	1			;TRUE
	STL	4			;ok
	J	@OT7
OT6
	LDLP	1			;SIG
	LDLP	5			;Completed
	.LDC	1
	BCNT				;len
	IN
	.LDC	0			;FALSE
	STL	4			;ok
OT7
	LDLP	2			;Next wsp
	ENDP
;- - - - - - - - - - - Join and Return - - - - - - - - - - -
OT8
	LDL	2
	AJW	4
	#pragma endasm
	}
