/*
 *	start.c
 *
 *	Handle initialization prior to calling "main".
 *
 *	Copyright 1987-1991 by Logical Systems.
 *
 *	WARNING:  THE "_main" ROUTINE NEEDS MODIFICATION FOR USE WITH THE
 *	"static link" GLOBAL DATA MODEL (IT MUST SETUP THE INITIAL VALUE)!
 */

#pragma	asm
	.ext	main			;Main program entry point
	.ext	_arg_get		;Get argv table and args
	.ext	_arg_size		;Get size of argv table and args
	.ext	_boot_chan_in		;Input boot channel address
	.ext	_boot_chan_out		;Output boot channel address
	.ext	ChanIn			;Read input bytes from channel
	.ext	ChanOut			;Write output bytes to channel
	.ext	exit			;Exit routine
	.ext	_host_chan_in		;Host services input channel
	.ext	_host_chan_out		;Host services output channel
	.ext	_HostIn			;Read bytes from host services channel
	.ext	_HostOut		;Write bytes to host services channel
	.ext	_node_number		;User supplied network node #
#pragma	endasm

/*
 *	_main
 *
 *	MUST BE MODIFIED FOR USE WITH THE STATIC LINK DATA MODEL (THE INITIAL
 *	VALUE OF THE STATIC LINK MUST BE SET AND THE DATA ACCESSES MUST BE
 *	CHANGED FROM ".ldc" TO THE APPROPRIATE TECHNIQUE).
 */
_main()
	{
#pragma	asm
	ajw	-2			;A bit of temp space
;
;	At this point WS(1) is the user supplied node #.
;
;	Input channel address is initially in "C"
;
	or
	stl	0			;Input channel address in "A"
	stl	0			;Save for a bit
	ldl	0
	.ldc	_boot_chan_in
	stnl	0			;Save input boot channel address
	ldl	0
	.ldc	_host_chan_in
	stnl	0			;Dup into host input channel address
	.ldc	ChanIn			;Address of "ChanIn" function
	.ldc	_HostIn			;Dup into "HostIn" function pointer
	stnl	0
	.ldc	4
	bcnt				;Areg will be 8 for T2, 16 for T4/T8
	ldl	0			;Get input channel address
	xor				;Compute output channel address
	stl	0			;Save for a bit
	ldl	0
	.ldc	_boot_chan_out
	stnl	0			;Save output boot channel address
	ldl	0
	.ldc	_host_chan_out
	stnl	0			;Dup into host output channel address
	.ldc	ChanOut			;Address of "ChanOut" function
	.ldc	_HostOut		;Dup into "HostOut" function pointer
	stnl	0
	ldl	1			;Processor node #
	.ldc	_node_number
	stnl	0			;Save processor node #
;
;	If virtual channel support has been requested ("_node_number" == 0),
;	just quit as this startup code isn't intended to handle them.
;
	ldl	1
	eqc	0
	cj	@main0
	.ldc	1
	call	@exit			;Terminate with error exit
;
;	Get/fake "argv"/"argc" stuff.
;
main0
	ldl	1
	eqc	1			;If node #1, get argv/argc stuff
	cj	@main1			;Jump if not
	call	@_arg_size		;Get needed size of argv table and args
	.ldc	2
	bcnt
	diff				;Since we already have two words...
	ldlp	0			;Point to current WS
	rev
	diff				;Compute new WS
	gajw			
	ldlp	0			;Current WS
	call	@_arg_get		;Get argv vector and arguments
	.ldc	0
	rev				;B is NULL env ptr, A is argc
	ldlp	0
	rev				;C is env ptr, B is argv, A is argc
	call	@main			;Call user program
	j	@main2			;Default to non error exit
main1
	ldlp	1
	stl	0			;argv[0] value
	.ldc	0
	stl	1			;argv[0] points to this
	.ldc	0			;Environment pointer
	ldlp	0			;ARGV
	.ldc	1			;ARGC
	call	@main
main2
	.ldc	0
	call	@exit			;Default to non error exit
#pragma	endasm
	}
