/*
 *	strcmp - compare string s1 to s2
 *
 *	Assembly language version copyright 1988, 1989 by Logical Systems
 */

#include	<inline.h>
#include	<string.h>

int				/* <0 for <, 0 for ==, >0 for > */
strcmp(const char *s1, const char *s2)
	{
#ifndef	ISTC
	register const	char	*scan1;
	register const	char	*scan2;

	scan1 = s1;
	scan2 = s2;
	while(*scan1 != '\0' && *scan1 == *scan2)
		{
		scan1++;
		scan2++;
		}
/*
 *	The following case analysis is necessary so that characters which look
 *	negative collate low against normal characters but high against the
 *	end-of-string NUL.
 */
	if(*scan1 == '\0' && *scan2 == '\0')
		return(0);
	else if(*scan1 == '\0')
		return(-1);
	else if(*scan2 == '\0')
		return(1);
	else
		return(*scan1 - *scan2);
#else	/* ISTC */
	#pragma	asm
;
;	The following code assumes characters are unsigned.
;
	ldl	[s2]
	adc	-1			;--s2
	stl	[s2]
	ldl	[s1]
	adc	-1			;--s1
	.ldc	0
loop
	ldl	[s2]
	adc	1			;++s2
	stl	[s2]
	add				;s1 (flush zero off top of stack)
	adc	1			;++s1
#ifdef	T800
	dup
#else
	stl	[s1]
	ldl	[s1]
	ldl	[s1]
#endif	/* T800 */
	lb				;*s1
#ifdef	T800
	dup
#else
	stl	[s1]
	ldl	[s1]
	ldl	[s1]
#endif	/* T800 */
	cj	@str1_end		;Jump if *str1 == 0
	ldl	[s2]
	lb				;*s2
	diff				;*s1-*s2
	cj	@loop			;Jump if equal (not done)
;
;	We know that *s1 != *s2 and that *s1 != '\0'
;
	lb				;*s1
	ldl	[s2]
	lb				;*s2
	diff				;*s1-*s2
	ret
;
;	We know that *s1 == '\0'
;
str1_end
	ldl	[s2]
	lb				;*s2
	cj	@equal			;Jump if *s2 == '\0'
	.ldc	-1			;Otherwise s1 < s2
	ret
equal
	ret				;s1 == s2
	#pragma	endasm
#endif	/* !ISTC */
	}
