/*
 *	File:	tan64.c
 *
 *	Implements T800/T414 64 bit floating point "tan(x)".
 *
 *	Based on INMOS supplied code.  Modified by Logical Systems for correct
 *	ANSI "C" setting of "errno" in ERANGE/EDOM situations.
 */

#include	<inline.h>
#include	<math.h>
#include	<stddef.h>

#pragma	asm_expand			/* Recognize EDOM/ERANGE in "asm" */

double
tan(double x)
	{
	#pragma	asm
#ifdef	T800
;
;	T800 64 bit version
;
	.ext	_argr
	.ext	errno
	_asm_ajw(-21);
	.ldc	data
	stl	20
	.ldc	0
	stl	13
	ldlp	[x]
	fpldnldb
	fpnan
	stl	13
	ldlp	[x]
	fpldnldb
	fpuabs
	ldlp	18
	fpstnldb
	ldl	13
	cj	@L1
	ldlp	[x]
	ldlp	14
	.ldc	8
	move
	.ldc	EDOM			;Domain error (input is NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	j	@L13
	.align
data:	.dw	0x54442d18
	.dw	0x419921fb
;
;	The following floating point constant represents the value of the
;	"inaccurate" NaN.  The original INMOS code used a value for this which
;	is inconsistent with the latest INMOS Compiler Writers' Guide.  The
;	value has been changed to reflect the one used in the "Guide".
;
	.dw	0x80000000		;Was 0x00000004
	.dw	0x7ff00000		;Was 0x7FF00000
	.dw	0x54442d18
	.dw	0x3fe921fb
	.dw	0x54442d18
	.dw	0x3ff921fb
	.dw	0x33145c07
	.dw	0x3c91a626
	.dw	0x00000000
	.dw	0x3e500000
	.dw	0x2ea2c724
	.dw	0xbef2bab7
	.dw	0xa63baadf
	.dw	0x3f6c0e82
	.dw	0xe54d0900
	.dw	0xbfc112b5
	.dw	0xf07678ea
	.dw	0x3ea0b774
	.dw	0x99094842
	.dw	0xbf346f64
	.dw	0xa17e215a
	.dw	0x3f9a479e
	.dw	0x47fbd9d6
	.dw	0xbfdddeb0
	.dw	0x00000000
	.dw	0x3ff00000
;
;	The following floating point constant represents the value of the
;	"unstable" NaN.  The original INMOS code used a value for this which
;	is inconsistent with the latest INMOS Compiler Writers' Guide.  The
;	value has been changed to reflect the one used in the "Guide".
;
	.dw	0x00000000		;Was 0x00000008
	.dw	0x7ff00001		;Was 0x7FF00000
L1:	ldlp	18
	fpldnldb
	ldl	20
	fpldnldb
	fpgt
	cj	@L2
	ldl	20
	ldnlp	2
	ldlp	14
	.ldc	8
	move
	j	@L13
L2:	.ldc	0
	stl	12
	.ldc	0
	stl	11
	ldlp	18
	fpldnldb
	ldl	20
	ldnlp	4
	fpldnldb
	fpgt
	cj	@L5
	.ldc	0
	stl	7
	ldl	20
	ldnlp	6
	ldlp	5
	.ldc	8
	move
	ldl	20
	ldnlp	8
	ldlp	3
	.ldc	8
	move
	ldlp	3
	stl	2
	ldlp	5
	stl	1
	ldlp	18
	stl	0
	ldlp	18
	ldlp	8
	ldlp	7
	call	@_argr
	ldl	8
	.ldc	1
	and
	eqc	1
	stl	11
	fpldzerodb
	ldlp	18
	fpldnldb
	fpgt
	cj	@L3
	fpldzerodb
	ldlp	[x]
	fpldnldb
	fpgt
	ldl	11
	diff
	eqc	0
	stl	12
	fpldzerodb
	ldlp	18
	fpldnldb
	fpsub
	ldlp	18
	fpstnldb
	j	@L4
L3:	fpldzerodb
	ldlp	[x]
	fpldnldb
	fpgt
	ldl	11
	diff
	eqc	0
	eqc	0
	stl	12
L4:	j	@L6
L5:	.ldc	0
	stl	11
	fpldzerodb
	ldlp	[x]
	fpldnldb
	fpgt
	stl	12
L6:	ldl	20
	ldnlp	10
	fpldnldb
	ldlp	18
	fpldnldb
	fpgt
	cj	@L7
	ldl	18
	stl	9
	ldl	19
	stl	10
	j	@L8
L7:	ldlp	18
	ldlp	18
	fpldnldb
	fpldnlmuldb
	ldlp	7
	fpstnldb
	ldl	20
	ldnlp	12
	ldlp	7
	fpldnldb
	fpldnlmuldb
	ldl	20
	ldnlp	14
	fpldnladddb
	ldlp	7
	fpldnlmuldb
	ldl	20
	ldnlp	16
	fpldnladddb
	ldlp	7
	fpldnlmuldb
	ldlp	18
	fpldnlmuldb
	ldlp	18
	fpldnladddb
	ldl	20
	ldnlp	18
	ldlp	7
	fpldnldb
	fpldnlmuldb
	ldl	20
	ldnlp	20
	fpldnladddb
	ldlp	7
	fpldnlmuldb
	ldl	20
	ldnlp	22
	fpldnladddb
	ldlp	7
	fpldnlmuldb
	ldl	20
	ldnlp	24
	fpldnladddb
	ldlp	7
	fpldnlmuldb
	ldl	20
	ldnlp	26
	fpldnladddb
	fpdiv
	ldlp	9
	fpstnldb
L8:	ldl	11
	cj	@L10
	ldlp	9
	fpldnldb
	fpldzerodb
	fpeq
	cj	@L9
	ldl	20
	ldnlp	28
	ldlp	9
	.ldc	8
	move
	j	@L10
L9:	ldlp	9
	ldl	20
	ldnlp	26
	fpldnldb
	fpldnldb
	fpdiv
	ldlp	9
	fpstnldb
L10:	ldl	12
	cj	@L12
	fpldzerodb
	ldlp	9
	fpldnldb
	fpsub
	ldlp	14
	fpstnldb
	j	@L13
L12:	ldl	9
	stl	14
	ldl	10
	stl	15
L13:	ldlp	14
	fpldnldb
	_asm_ajw(21);
	ret
#else	/* T800 */
;
;	T414 64 bit version (from D700D).  NO attempt is made here to optimize
;	the OCCAM generated code (for example see lines after label "L3", hope
;	to get to this someday...)
;
	.ext	errno
	.ext	_fdiv64
	.ext	_fix64
	.ext	_fmul64
	.ext	_FPstate
	.ext	_refl64
	.ext	_r64fmi
	.ext	_r64op
	.ext	_r64toi
	_asm_ajw(-22);
	.ldc	data
	stl	21
	ldlp	[x]
	ldlp	17
	.ldc	8
	move
	ldlp	15
	stl	14
	ldl	17
	ldl	14
	stnl	0
	ldl	18
	.ldc	2147483647		;~MOSTNEG
	and
	ldl	14
	stnl	1
	.ldc	2146435072		;RealInf
	ldl	14
	ldnl	1
	gt
	eqc	0
	cj	@L2
	.ldc	2146435072		;RealInf
	ldl	14
	ldnl	1
	diff
	eqc	0
	cj	@L1
	mint
	ldl	14
	ldnl	0
	mint
	xor
	gt
L1:	eqc	0
L2:	cj	@L5
	ldl	14
	ldnl	0
	ldl	14
	ldnl	1
	.ldc	2146435072		;RealInf
	diff
	or
	eqc	0
	cj	@L3
	ldl	21
	ldlp	19
	.ldc	8
	move
	.ldc	EDOM			;Domain error (input is Inf)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
	j	@L4
	.align
data:	.dw	0x00000000
	.dw	0x7ff00002
	.dw	0x80000000
	.dw	0x7ff00000
	.dw	0x6dc93883
	.dw	0x3fe45f30
	.dw	0x00000000
	.dw	0x3ff92200
	.dw	0x4b9ee59e
	.dw	0xbed2aeef
	.dw	0xe42f9822
	.dw	0x00034ae7
	.dw	0x9de5ebd3
	.dw	0xfffc95b4
	.dw	0x00000000
	.dw	0x7ff00001
	.dw	0x00000000
	.dw	0x3ff00000
	.dw	0x00000000
	.dw	0x00000000
L3:	ldl	17
	stl	12
	ldl	18
	stl	13
	ldl	12
	stl	19
	ldl	13
	stl	20
	.ldc	EDOM			;Domain error (input is NaN)
	_asm_eval1(&errno);
	stnl	0			;Set errno to EDOM
L4:	j	@L22
L5:	ldl	14
	ldnl	1
	.ldc	1100554747
	gt
	eqc	0
	cj	@L7
	ldl	14
	ldnl	1
	.ldc	1100554747
	diff
	eqc	0
	cj	@L6
	ldl	14
	ldnl	0
	mint
	xor
	.ldc	-733729512
	gt
L6:	eqc	0
L7:	eqc	0
	cj	@L8
	ldl	21
	ldnlp	2
	ldlp	19
	.ldc	8
	move
	j	@L22
L8:	.ldc	0
	stl	13
	.ldc	0
	stl	12
	.ldc	0
	ldl	18
	gt
	stl	13
	ldl	14
	ldnl	1
	.ldc	1072243195
	gt
	eqc	0
	cj	@L10
	ldl	14
	ldnl	1
	.ldc	1072243195
	diff
	eqc	0
	cj	@L9
	ldl	14
	ldnl	0
	mint
	xor
	.ldc	-733729512
	gt
L9:	eqc	0
L10:	eqc	0
	cj	@L13
	ldl	14
	stl	10
	ldl	21
	ldnlp	4
	stl	0
	.ldc	2
	ldl	10
	ldlp	8
	call	@_r64op
	ldlp	8
	.ldc	1
	call	@_r64toi
	stl	11
	ldl	11
	.ldc	1
	and
	eqc	1
	stl	12
	ldl	11
	ldlp	8
	call	@_r64fmi
	ldl	21
	ldnlp	6
	stl	0
	.ldc	2
	ldlp	8
	ldlp	4
	call	@_r64op
	ldlp	4
	stl	0
	.ldc	1
	ldl	10
	ldlp	2
	call	@_r64op
	ldl	21
	ldnlp	8
	stl	0
	.ldc	2
	ldlp	8
	ldlp	4
	call	@_r64op
	ldlp	4
	stl	0
	.ldc	1
	ldlp	2
	ldlp	6
	call	@_r64op
	ldlp	6
	ldl	10
	.ldc	8
	move
	.ldc	0
	ldl	14
	ldnl	1
	gt
	cj	@L11
	ldl	12
	ldl	13
	diff
	eqc	0
	stl	13
	ldl	14
	ldnl	0
	stl	10
	ldl	14
	ldnl	1
	.ldc	2147483647
	and
	stl	11
	ldlp	10
	ldl	14
	.ldc	8
	move
	j	@L12
L11:	ldl	12
	ldl	13
	diff
	eqc	0
	eqc	0
	stl	13
L12:	j	@L14
L13:	.ldc	0
	stl	12
L14:	.ldc	1045430272
	ldl	14
	ldnl	1
	gt
	eqc	0
	cj	@L16
	.ldc	1045430272
	ldl	14
	ldnl	1
	diff
	eqc	0
	cj	@L15
	mint
	ldl	14
	ldnl	0
	mint
	xor
	gt
L15:	eqc	0
L16:	eqc	0
	cj	@L17
	ldl	14
	stl	11
	ldl	11
	ldlp	19
	.ldc	8
	move
	j	@L18
L17:	ldl	14
	stl	11
	ldl	11
	ldlp	9
	call	@_fix64
	ldlp	9
	ldlp	9
	ldlp	7
	call	@_fmul64
	ldl	7
	stl	9
	ldl	8
	stl	10
	ldl	21
	ldnlp	10
	ldlp	9
	ldlp	7
	call	@_fmul64
	.ldc	0
	ldl	7
	.ldc	-343214651
	lsum
	stl	3
	ldl	8
	.ldc	-22053514
	ladd
	stl	4
	ldlp	3
	ldlp	9
	ldlp	5
	call	@_fmul64
	.ldc	0
	ldl	5
	.ldc	1431642736
	lsum
	stl	3
	ldl	6
	.ldc	357913941
	ladd
	stl	4
	ldlp	3
	ldlp	9
	ldlp	7
	call	@_fmul64
	ldl	21
	ldnlp	12
	ldlp	9
	ldlp	5
	call	@_fmul64
	.ldc	0
	ldl	5
	.ldc	-643473618
	lsum
	stl	1
	ldl	6
	.ldc	25066344
	ladd
	stl	2
	ldlp	1
	ldlp	9
	ldlp	3
	call	@_fmul64
	.ldc	0
	ldl	3
	.ldc	687380666
	lsum
	stl	1
	ldl	4
	.ldc	-495657269
	ladd
	stl	2
	ldlp	1
	ldlp	9
	ldlp	5
	call	@_fmul64
	ldl	5
	stl	1
	.ldc	0
	ldl	6
	.ldc	1073741824
	ladd
	stl	2
	ldlp	1
	ldlp	7
	ldlp	3
	call	@_fdiv64
	ldlp	3
	ldlp	7
	call	@_refl64
	ldl	11
	stl	0
	.ldc	2
	ldlp	7
	ldlp	5
	call	@_r64op
	ldl	11
	stl	0
	.ldc	0
	ldlp	5
	ldlp	19
	call	@_r64op
L18:	ldl	12
	cj	@L20
	ldlp	19
	stl	11
	ldl	11
	ldnl	0
	ldl	11
	ldnl	1
	or
	eqc	0
	cj	@L19
	ldl	11
	stl	10
	ldl	21
	ldnlp	14
	ldl	10
	.ldc	8
	move
	j	@L20
L19:	ldlp	19
	stl	0
	.ldc	3
	ldl	21
	ldnlp	16
	ldlp	10
	call	@_r64op
	ldl	10
	stl	19
	ldl	11
	stl	20
L20:	ldl	13
	cj	@L22
	ldlp	19
	stl	0
	.ldc	1
	ldl	21
	ldnlp	18
	ldlp	10
	call	@_r64op
	ldl	10
	stl	19
	ldl	11
	stl	20
L22:	ldlp	19
	.ldc	_FPstate		;Addr of "soft" FAreg
	.ldc	8
	move
	_asm_ajw(22);
	ret
#endif	/* T800 */
	#pragma	endasm
	}
