/*
 *	tmisc.c
 *
 *	Miscellaneous primitives for the T800/T414 Transputers.
 *
 *	Copyright 1988, 1989 by Logical Systems
 */

#include	<inline.h>
#include	<conc.h>

#undef	GetHiPriQ

void
GetHiPriQ(void *results)
	{
	#pragma	asm
;
;	Saves High Priority Process Queue pointers (back ptr, then front ptr)
;	at "results".
;
	ldl	[results]
	saveh
	#pragma endasm
	}

#undef	GetLoPriQ

void
GetLoPriQ(void *results)
	{
	#pragma	asm
;
;	Saves the low priority process queue (back ptr, then front ptr) at
;	"results".
;
	ldl	[results]
	savel
	#pragma endasm
	}

#undef	SetHiPriQ

void
SetHiPriQ(void *front,void *back)
	{
	#pragma asm
;
;	Store the High Priority Queue pointers
;
	ldl	[front]
	sthf
	ldl	[back]
	sthb
	#pragma	endasm
	}

#undef	SetLoPriQ

void
SetLoPriQ(void *front,void *back)
	{
	#pragma asm
;
;	Store the low priority process queue pointer
;
	ldl	[front]
	stlf
	ldl	[back]
	stlb
	#pragma endasm
	}
