/*
 *	uprint.c
 *
 *	"stripped" printf.
 *
 *	Copyright 1987-1992 by Logical Systems.
 */

#include	<stdio.h>


#define	TRUE	1
#define	FALSE	0


/*
 *	Convert an integer to a string in any base (2-36).
 */
static	char	*
_itob(int n,char *s,int base)
	{
	register	int	c;
	register	int	negative;
	register	char	*p;
	register	char	*q;
	register unsigned int	u;

	if(n < 0 && base == -10)
		{
		negative = TRUE;
		u = -n;
		}
	else
		{
		negative = FALSE;
		u = n;
		}
	if(base == -10)			/* Signals signed conversion */
		base = 10;
	p = q = s;
	do
		{			/* Generate digits in reverse order */
		if((*p = u % base + '0') > '9')
			*p += ('A' - ('9' + 1));
		++p;
		} while ((u /= base) > 0);
	if(negative)
		*p++ = '-';
	*p = '\0';			/* Terminate the string */
	while(q < --p)
		{			/* Reverse the digits */
		c = *q;
		*q++ = *p;
		*p = c;
		}
	return (s);
	}

/*
 *	Short version of printf to save space.
 */
void
_printf(char *arg,...)
	{
	register	char	**argp;
	register	int	base;
	register	int	c;
	register	char	*fmt;
	char			s[80];

	argp = &arg;

	fmt = *argp;
	while(c = *fmt++)
		{
		if(c != '%')
			{
			putchar(c);
			continue;
			}
		while(*fmt >= '0' && *fmt <= '9')
			fmt++;
		switch(c = *fmt++)
			{
			case 'l':
				switch(c = *fmt++)
					{
					case 'd':
						base = -10;
						goto prt;
					case 'o':
						base = 8;
						goto prt;
					case 'u':
						base = 10;
						goto prt;
					case 'x':
						base = 16;
						goto prt;
					default:
						putchar(c);
						continue;
					}

			case 'c':
				putchar((int) (*++argp));
				continue;

			case 'd':
				base = -10;
				goto prt;

			case 'o':
				base = 8;
				goto prt;

			case 'u':
				base = 10;
				goto prt;

			case 'x':
				base = 16;
		prt:
				fputs(_itob((int) (*++argp),s,base),stdout);
				continue;

			case 's':
				fputs(*++argp,stdout);
				continue;

			default:
				putchar(c);
				continue;
			}
		}
	}
